CREATE OR REPLACE PACKAGE Seguretat AS
  PROCEDURE Visita_Inserir          (p_idVisita OUT Visita.idVisita%TYPE, p_nomEmpresa IN Visita.nomEmpresa%TYPE, p_nomDelegacio IN Visita.nomDelegacio%TYPE,
                                     p_idEmpleat IN Visita.idEmpleat%TYPE, p_ID IN Visita.ID%TYPE, p_horaEntrada IN Visita.horaEntrada%TYPE,
                                     p_horaSortida IN Visita.horaSortida%TYPE, p_motiuVisita IN Visita.motiuVisita%TYPE, p_sortida OUT VARCHAR2);
  PROCEDURE Visita_ActSortida       (p_nomEmpresa IN Visita.nomEmpresa%TYPE, p_nomDelegacio IN Visita.nomDelegacio%TYPE,
                                     p_idEmpleat IN Visita.idEmpleat%TYPE, p_ID IN Visita.ID%TYPE, p_horaSortida IN Visita.horaSortida%TYPE, p_sortida OUT VARCHAR2);
  PROCEDURE Visita_LlistatDelegacio (p_nomEmpresa IN Visita.nomEmpresa%TYPE, p_nomDelegacio IN Visita.nomDelegacio%TYPE,
                                     p_momentInici IN Visita.horaEntrada%TYPE, p_momentFi IN Visita.horaEntrada%TYPE, p_LlistatVisitaDelegacio OUT SYS_REFCURSOR, 
                                     p_sortida OUT VARCHAR2);
  PROCEDURE Visita_LlistatEmpleat   (p_idEmpleat IN Visita.idEmpleat%TYPE, p_ID IN Visita.ID%TYPE, p_momentInici IN Visita.horaEntrada%TYPE, p_momentFi IN Visita.horaEntrada%TYPE, 
                                     p_LlistatVisitaEmpleat OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2);  
  PROCEDURE Visita_Esborrar         (p_idVisita IN Visita.idVisita%TYPE, p_sortida OUT VARCHAR2);  
  PROCEDURE Lliurament_Inserir          (p_idLliurament OUT Lliurament.idLliurament%TYPE, p_nomEmpresa IN Lliurament.nomEmpresa%TYPE, p_nomDelegacio IN Lliurament.nomDelegacio%TYPE,
                                         p_idEmpleat IN Lliurament.idEmpleat%TYPE, p_ID IN Lliurament.ID%TYPE, p_horaLliurament IN Lliurament.horaLliurament%TYPE,
                                         p_nomTransportista IN Lliurament.nomTransportista%TYPE, p_sortida OUT VARCHAR2);
  PROCEDURE Lliurament_LlistatDelegacio (p_nomEmpresa IN Lliurament.nomEmpresa%TYPE, p_nomDelegacio IN Lliurament.nomDelegacio%TYPE,
                                         p_momentInici IN Lliurament.horaLliurament%TYPE, p_momentFi IN Lliurament.horaLliurament%TYPE, 
                                         p_LlistatLliuramentDelegacio OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2);
  PROCEDURE Lliurament_LlistatEmpleat   (p_idEmpleat IN Visita.idEmpleat%TYPE, p_ID IN Visita.ID%TYPE, p_momentInici IN Visita.horaEntrada%TYPE, p_momentFi IN Visita.horaEntrada%TYPE, 
                                         p_LlistatLliuramentEmpleat OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2);  
  PROCEDURE Lliurament_Esborrar         (p_idLliurament IN Lliurament.idLliurament%TYPE, p_sortida OUT VARCHAR2);
  PROCEDURE Incidencia_Inserir          (p_idIncidencia OUT Incidencia.idIncidencia%TYPE, p_nomEmpresa IN Incidencia.nomEmpresa%TYPE, p_nomDelegacio IN Incidencia.nomDelegacio%TYPE,
                                         p_horaIncidencia IN Incidencia.horaIncidencia%TYPE, p_tipusIncidencia IN Incidencia.tipusIncidencia%TYPE, p_sortida OUT VARCHAR2);
  PROCEDURE Incidencia_LlistatDelegacio (p_nomEmpresa IN Incidencia.nomEmpresa%TYPE, p_nomDelegacio IN Incidencia.nomDelegacio%TYPE, p_tipusIncidencia IN Incidencia.tipusIncidencia%TYPE,
                                         p_momentInici IN Incidencia.horaIncidencia%TYPE, p_momentFi IN Incidencia.horaIncidencia%TYPE, 
                                         p_LlistatIncidenciaDelegacio OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2);
  PROCEDURE Incidencia_Esborrar         (p_idIncidencia IN Incidencia.idIncidencia%TYPE, p_sortida OUT VARCHAR2);
  PROCEDURE PermisAcces_Inserir            (p_idPermis OUT PermisAcces.idPermis%TYPE, p_idZona IN PermisAcces.idZona%TYPE,
                                            p_nomEmpresa IN PermisAcces.nomEmpresa%TYPE, p_nomDelegacio IN PermisAcces.nomDelegacio%TYPE, p_ID IN PermisAcces.ID%TYPE,
                                            p_nomDepartament IN PermisAcces.nomDepartament%TYPE, p_horaInici IN PermisAcces.horaInici%TYPE, p_horaFi IN PermisAcces.horaFi%TYPE,
                                            p_sortida OUT VARCHAR2);
  PROCEDURE PermisAcces_LlistatZona        (p_idZona IN PermisAcces.idZona%TYPE, p_nomEmpresa IN PermisAcces.nomEmpresa%TYPE, p_nomDelegacio IN PermisAcces.nomDelegacio%TYPE, 
                                            p_LlistatPermisAccesZona OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2);
  PROCEDURE PermisAcces_LlistatPersona     (p_ID IN PermisAcces.ID%TYPE, p_LlistatPermisAccesPersona OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2);
  PROCEDURE PermisAcces_LlistatDepartament (p_nomDepartament IN PermisAcces.nomDepartament%TYPE, p_nomEmpresa IN PermisAcces.nomEmpresa%TYPE, p_nomDelegacio IN PermisAcces.nomDelegacio%TYPE,
                                            p_LlistatPermisAccesDpt OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2);
  PROCEDURE PermisAcces_Esborrar           (p_idZona IN PermisAcces.idZona%TYPE, p_nomEmpresa IN PermisAcces.nomEmpresa%TYPE, p_nomDelegacio IN PermisAcces.nomDelegacio%TYPE, 
                                            p_ID IN PermisAcces.ID%TYPE, p_nomDepartament IN PermisAcces.nomDepartament%TYPE, p_sortida OUT VARCHAR2);
  PROCEDURE PermisAcces_EsborrarPK         (p_idPermis IN PermisAcces.idPermis%TYPE, p_sortida OUT VARCHAR2);                               
END Seguretat;
/

CREATE OR REPLACE PACKAGE BODY Seguretat AS
/********************************************
 * Nom procediment: Visita_Inserir
 * Descripci:      insereix una nova visita 
 ********************************************/
PROCEDURE Visita_Inserir(p_idVisita OUT Visita.idVisita%TYPE, p_nomEmpresa IN Visita.nomEmpresa%TYPE, p_nomDelegacio IN Visita.nomDelegacio%TYPE,
                         p_idEmpleat IN Visita.idEmpleat%TYPE, p_ID IN Visita.ID%TYPE, p_horaEntrada IN Visita.horaEntrada%TYPE,
                         p_horaSortida IN Visita.horaSortida%TYPE, p_motiuVisita IN Visita.motiuVisita%TYPE, p_sortida OUT VARCHAR2) IS
  cntDelegacio NUMBER;
  cntEmpleat NUMBER;
  DELEGACIO_NO_TROBADA EXCEPTION;
  EMPLEAT_NO_TROBAT EXCEPTION;
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  BEGIN
  vProcedureName := 'Visita_Inserir';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  cntDelegacio := 0;
  cntEmpleat := 0;
  SELECT COUNT(1) INTO cntDelegacio FROM DELEGACIO where nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  IF (cntDelegacio = 0) THEN
    RAISE DELEGACIO_NO_TROBADA;
  END IF;                                                                                                            
  SELECT COUNT(1) INTO cntEmpleat FROM EMPLEAT where idEmpleat = p_idEmpleat AND ID = p_ID;
  IF (cntEmpleat = 0) THEN
    RAISE EMPLEAT_NO_TROBAT;
  END IF;                   
  p_idVisita := SEQ_IDVISITA.nextval;
  INSERT INTO VISITA(idVisita, nomEmpresa, nomDelegacio, idEmpleat, ID, horaEntrada, horaSortida, motiuVisita) 
  VALUES (p_idVisita, p_nomEmpresa, p_nomDelegacio, p_idEmpleat, p_ID, p_horaEntrada, p_horaSortida, p_motiuVisita);
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN DELEGACIO_NO_TROBADA THEN
    p_sortida:='ERROR: delegacio no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN EMPLEAT_NO_TROBAT THEN
    p_sortida:='ERROR: empleat no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  
  WHEN DUP_VAL_ON_INDEX THEN
    p_sortida:='ERROR: visita existent - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR en inserir - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/**************************************************
 * Nom procediment: Visita_ActSortida
 * Descripci:      actualitza hora sortida visita 
 **************************************************/
PROCEDURE Visita_ActSortida (p_nomEmpresa IN Visita.nomEmpresa%TYPE, p_nomDelegacio IN Visita.nomDelegacio%TYPE,
                             p_idEmpleat IN Visita.idEmpleat%TYPE, p_ID IN Visita.ID%TYPE, p_horaSortida IN Visita.horaSortida%TYPE, p_sortida OUT VARCHAR2) IS
  cntDelegacio   NUMBER;
  cntEmpleat     NUMBER;
  cntVisita      NUMBER;
  cntVisitaNoAct NUMBER;
  DELEGACIO_NO_TROBADA EXCEPTION;
  EMPLEAT_NO_TROBAT EXCEPTION;
  VISITA_NO_TROBADA EXCEPTION;
  VISITA_ACTUALITZADA EXCEPTION;
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  BEGIN
  vProcedureName := 'Visita_ActSortida';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  cntDelegacio := 0;
  cntEmpleat := 0;
  cntVisita := 0;
  SELECT COUNT(1) INTO cntDelegacio FROM DELEGACIO where nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  IF (cntDelegacio = 0) THEN
    RAISE DELEGACIO_NO_TROBADA;
  END IF;                              
  SELECT COUNT(1) INTO cntEmpleat FROM EMPLEAT where idEmpleat = p_idEmpleat AND ID = p_ID;
  IF (cntEmpleat = 0) THEN
    RAISE EMPLEAT_NO_TROBAT;
  END IF;                                                 
  SELECT COUNT(1) INTO cntVisita FROM VISITA WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio AND
  idEmpleat = p_idEmpleat AND ID = p_ID;
  IF (cntVisita = 0) THEN
    RAISE VISITA_NO_TROBADA;
  END IF;                   
  SELECT COUNT(1) INTO cntVisitaNoAct FROM VISITA WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio AND
  idEmpleat = p_idEmpleat AND ID = p_ID AND horaEntrada = horaSortida;
  IF (cntVisitaNoAct = 0) THEN
    RAISE VISITA_ACTUALITZADA;
  END IF;                   
  UPDATE VISITA SET horaSortida = p_horaSortida WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio AND
  idEmpleat = p_idEmpleat AND ID = p_ID AND horaEntrada = horaSortida;
  
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN DELEGACIO_NO_TROBADA THEN
    p_sortida:='ERROR: delegacio no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN EMPLEAT_NO_TROBAT THEN
    p_sortida:='ERROR: empleat no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN VISITA_NO_TROBADA THEN
    p_sortida:='ERROR: visita no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN VISITA_ACTUALITZADA THEN
    p_sortida:='ERROR: visita ja actualitzada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR en inserir - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/*****************************************************************************
 * Nom procediment: Visita_LlistatDelegacio
 * Descripci:      obt el llistat de visites per delegaci
 *                  entre els moments inicial i final passats com a parmetre
 *****************************************************************************/
PROCEDURE Visita_LlistatDelegacio (p_nomEmpresa IN Visita.nomEmpresa%TYPE, p_nomDelegacio IN Visita.nomDelegacio%TYPE,
                                   p_momentInici IN Visita.horaEntrada%TYPE, p_momentFi IN Visita.horaEntrada%TYPE, p_LlistatVisitaDelegacio OUT SYS_REFCURSOR, 
                                   p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  cntDelegacio NUMBER;
  DELEGACIO_NO_VISITA EXCEPTION;
  BEGIN
  vProcedureName := 'Visita_LlistatDelegacio';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  
  SELECT COUNT(1) INTO cntDelegacio FROM VISITA WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  IF (cntDelegacio = 0) THEN
    RAISE DELEGACIO_NO_VISITA;
  END IF;
  
  OPEN p_LlistatVisitaDelegacio FOR
      SELECT * FROM VISITA WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio AND 
      horaEntrada >= p_momentInici AND horaSortida <= p_momentFi
      ORDER BY horaEntrada, idEmpleat, ID;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN DELEGACIO_NO_VISITA THEN
    p_sortida:='ERROR: visita delegacio no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/*****************************************************************************
 * Nom procediment: Visita_LlistatEmpleat
 * Descripci:      obt el llistat de visites per empleat
 *                  entre els moments inicial i final passats com a parmetre
 *****************************************************************************/                                     
PROCEDURE Visita_LlistatEmpleat (p_idEmpleat IN Visita.idEmpleat%TYPE, p_ID IN Visita.ID%TYPE, p_momentInici IN Visita.horaEntrada%TYPE, p_momentFi IN Visita.horaEntrada%TYPE, 
                                 p_LlistatVisitaEmpleat OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  cntEmpleat NUMBER;
  EMPLEAT_NO_VISITA EXCEPTION;
  BEGIN
  vProcedureName := 'Visita_LlistatEmpleat';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  
  SELECT COUNT(1) INTO cntEmpleat FROM VISITA WHERE idEmpleat = p_idEmpleat AND ID = p_ID;
  IF (cntEmpleat = 0) THEN
    RAISE EMPLEAT_NO_VISITA;
  END IF;
  
  OPEN p_LlistatVisitaEmpleat FOR
      SELECT * FROM VISITA WHERE idEmpleat = p_idEmpleat AND ID = p_ID AND 
      horaEntrada >= p_momentInici AND horaSortida <= p_momentFi
      ORDER BY horaEntrada;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN EMPLEAT_NO_VISITA THEN
    p_sortida:='ERROR: visita empleat no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/**************************************
 * Nom procediment: Visita_Esborrar
 * Descripci:      elimina una visita
 **************************************/
PROCEDURE Visita_Esborrar(p_idVisita IN Visita.idVisita%TYPE, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  VISITA_NO_TROBADA EXCEPTION;
  BEGIN
  vProcedureName := 'Visita_Esborrar';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  DELETE FROM VISITA WHERE idVisita = p_idVisita;
  IF (SQL%NOTFOUND) THEN
     RAISE VISITA_NO_TROBADA;
  END IF;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN VISITA_NO_TROBADA THEN
    p_sortida:='ERROR: visita no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR en esborrar - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/**********************************************
 * Nom procediment: Lliurament_Inserir
 * Descripci:      insereix un nou lliurament 
 **********************************************/
PROCEDURE Lliurament_Inserir(p_idLliurament OUT Lliurament.idLliurament%TYPE, p_nomEmpresa IN Lliurament.nomEmpresa%TYPE, p_nomDelegacio IN Lliurament.nomDelegacio%TYPE,
                             p_idEmpleat IN Lliurament.idEmpleat%TYPE, p_ID IN Lliurament.ID%TYPE, p_horaLliurament IN Lliurament.horaLliurament%TYPE,
                             p_nomTransportista IN Lliurament.nomTransportista%TYPE, p_sortida OUT VARCHAR2) IS
  cntDelegacio NUMBER;
  cntEmpleat   NUMBER;
  DELEGACIO_NO_TROBADA EXCEPTION;
  EMPLEAT_NO_TROBAT EXCEPTION;
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  BEGIN
  vProcedureName := 'Lliurament_Inserir';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  cntDelegacio := 0;
  cntEmpleat := 0;
  SELECT COUNT(1) INTO cntDelegacio FROM DELEGACIO where nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  IF (cntDelegacio = 0) THEN
    RAISE DELEGACIO_NO_TROBADA;
  END IF;                              
  SELECT COUNT(1) INTO cntEmpleat FROM EMPLEAT where idEmpleat = p_idEmpleat AND ID = p_ID;
  IF (cntEmpleat = 0) THEN
    RAISE EMPLEAT_NO_TROBAT;
  END IF;                   
  p_idLliurament := SEQ_IDLLIURAMENT.nextval;
  INSERT INTO LLIURAMENT(idLliurament, nomEmpresa, nomDelegacio, idEmpleat, ID, horaLliurament, nomTransportista) 
  VALUES (p_idLliurament, p_nomEmpresa, p_nomDelegacio, p_idEmpleat, p_ID, p_horaLliurament, p_nomTransportista);
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN DELEGACIO_NO_TROBADA THEN
    p_sortida:='ERROR: delegacio no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN EMPLEAT_NO_TROBAT THEN
    p_sortida:='ERROR: empleat no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  
  WHEN DUP_VAL_ON_INDEX THEN
    p_sortida:='ERROR: lliurament existent - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR en inserir - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/*****************************************************************************
 * Nom procediment: Lliurament_LlistatDelegacio
 * Descripci:      obt el llistat de lliuraments per delegaci
 *                  entre els moments inicial i final passats com a parmetre
 *****************************************************************************/
PROCEDURE Lliurament_LlistatDelegacio (p_nomEmpresa IN Lliurament.nomEmpresa%TYPE, p_nomDelegacio IN Lliurament.nomDelegacio%TYPE,
                                       p_momentInici IN Lliurament.horaLliurament%TYPE, p_momentFi IN Lliurament.horaLliurament%TYPE, 
                                       p_LlistatLliuramentDelegacio OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  cntDelegacio NUMBER;
  DELEGACIO_NO_LLIURAMENT EXCEPTION;
  BEGIN
  vProcedureName := 'Lliurament_LlistatDelegacio';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  
  SELECT COUNT(1) INTO cntDelegacio FROM LLIURAMENT WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  IF (cntDelegacio = 0) THEN
    RAISE DELEGACIO_NO_LLIURAMENT;
  END IF;
  
  OPEN p_LlistatLliuramentDelegacio FOR
      SELECT * FROM LLIURAMENT WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio AND 
      horaLliurament >= p_momentInici AND horaLliurament <= p_momentFi
      ORDER BY horaLliurament, idEmpleat, ID;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN DELEGACIO_NO_LLIURAMENT THEN
    p_sortida:='ERROR: lliurament delegacio no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/*****************************************************************************
 * Nom procediment: Lliurament_LlistatEmpleat
 * Descripci:      obt el llistat de lliuraments per empleat
 *                  entre els moments inicial i final passats com a parmetre
 *****************************************************************************/
PROCEDURE Lliurament_LlistatEmpleat (p_idEmpleat IN Visita.idEmpleat%TYPE, p_ID IN Visita.ID%TYPE, p_momentInici IN Visita.horaEntrada%TYPE, p_momentFi IN Visita.horaEntrada%TYPE, 
                                     p_LlistatLliuramentEmpleat OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  cntEmpleat NUMBER;
  EMPLEAT_NO_LLIURAMENT EXCEPTION;
  BEGIN
  vProcedureName := 'Lliurament_LlistatEmpleat';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  
  SELECT COUNT(1) INTO cntEmpleat FROM LLIURAMENT WHERE idEmpleat = p_idEmpleat AND ID = p_ID;
  IF (cntEmpleat = 0) THEN
    RAISE EMPLEAT_NO_LLIURAMENT;
  END IF;
  
  OPEN p_LlistatLliuramentEmpleat FOR
      SELECT * FROM LLIURAMENT WHERE idEmpleat = p_idEmpleat AND ID = p_ID AND 
      horaLliurament >= p_momentInici AND horaLliurament <= p_momentFi
      ORDER BY horaLliurament;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN EMPLEAT_NO_LLIURAMENT THEN
    p_sortida:='ERROR: lliurament empleat no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/*****************************************
 * Nom procediment: Lliurament_Esborrar
 * Descripci:      elimina un lliurament
 *****************************************/
PROCEDURE Lliurament_Esborrar(p_idLliurament IN Lliurament.idLliurament%TYPE, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  LLIURAMENT_NO_TROBAT EXCEPTION;
  BEGIN
  vProcedureName := 'Lliurament_Esborrar';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  DELETE FROM LLIURAMENT WHERE idLliurament = p_idLliurament;
  IF (SQL%NOTFOUND) THEN
     RAISE LLIURAMENT_NO_TROBAT;
  END IF;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN LLIURAMENT_NO_TROBAT THEN
    p_sortida:='ERROR: lliurament no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR en esborrar - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/************************************************
 * Nom procediment: Incidencia_Inserir
 * Descripci:      insereix una nova incidncia
 ************************************************/
PROCEDURE Incidencia_Inserir (p_idIncidencia OUT Incidencia.idIncidencia%TYPE, p_nomEmpresa IN Incidencia.nomEmpresa%TYPE, p_nomDelegacio IN Incidencia.nomDelegacio%TYPE,
                              p_horaIncidencia IN Incidencia.horaIncidencia%TYPE, p_tipusIncidencia IN Incidencia.tipusIncidencia%TYPE, p_sortida OUT VARCHAR2) IS
  cntDelegacio NUMBER;
  DELEGACIO_NO_TROBADA EXCEPTION;
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  BEGIN
  vProcedureName := 'Incidencia_Inserir';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  cntDelegacio := 0;
  SELECT COUNT(1) INTO cntDelegacio FROM DELEGACIO where nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  IF (cntDelegacio = 0) THEN
    RAISE DELEGACIO_NO_TROBADA;
  END IF;                              
  p_idIncidencia := SEQ_IDINCIDENCIA.nextval;
  INSERT INTO INCIDENCIA(idIncidencia, nomEmpresa, nomDelegacio, horaIncidencia, tipusIncidencia) 
  VALUES (p_idIncidencia, p_nomEmpresa, p_nomDelegacio, p_horaIncidencia, p_tipusIncidencia);
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN DELEGACIO_NO_TROBADA THEN
    p_sortida:='ERROR: delegacio no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  
  WHEN DUP_VAL_ON_INDEX THEN
    p_sortida:='ERROR: incidencia existent - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR en inserir - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;
  
/*****************************************************************************
 * Nom procediment: Incidencia_LlistatDelegacio
 * Descripci:      obt el llistat d'incidncies per delegaci
 *                  entre els moments inicial i final passats com a parmetre
 *****************************************************************************/
PROCEDURE Incidencia_LlistatDelegacio (p_nomEmpresa IN Incidencia.nomEmpresa%TYPE, p_nomDelegacio IN Incidencia.nomDelegacio%TYPE, p_tipusIncidencia IN Incidencia.tipusIncidencia%TYPE,
                                       p_momentInici IN Incidencia.horaIncidencia%TYPE, p_momentFi IN Incidencia.horaIncidencia%TYPE, 
                                       p_LlistatIncidenciaDelegacio OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  cntDelegacio NUMBER;
  DELEGACIO_NO_INCIDENCIA EXCEPTION;
  BEGIN
  vProcedureName := 'Incidencia_LlistatDelegacio';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  
  SELECT COUNT(1) INTO cntDelegacio FROM INCIDENCIA WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  IF (cntDelegacio = 0) THEN
    RAISE DELEGACIO_NO_INCIDENCIA;
  END IF;
  IF (LTRIM(p_tipusIncidencia) IS NOT NULL) THEN
    OPEN p_LlistatIncidenciaDelegacio FOR
        SELECT * FROM INCIDENCIA WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio AND 
        tipusIncidencia = p_tipusIncidencia AND horaIncidencia >= p_momentInici AND horaIncidencia <= p_momentFi
        ORDER BY horaIncidencia;
  ELSE
    OPEN p_LlistatIncidenciaDelegacio FOR
        SELECT * FROM INCIDENCIA WHERE nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio AND 
        horaIncidencia >= p_momentInici AND horaIncidencia <= p_momentFi
        ORDER BY horaIncidencia;
  END IF;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN DELEGACIO_NO_INCIDENCIA THEN
    p_sortida:='ERROR: incidencia delegacio no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/******************************************
 * Nom procediment: Incidencia_Esborrar
 * Descripci:      elimina una incidncia
 ******************************************/
PROCEDURE Incidencia_Esborrar (p_idIncidencia IN Incidencia.idIncidencia%TYPE, p_sortida OUT VARCHAR2) IS
status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  INCIDENCIA_NO_TROBADA EXCEPTION;
  BEGIN
  vProcedureName := 'Incidencia_Esborrar';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  DELETE FROM INCIDENCIA WHERE idIncidencia = p_idIncidencia;
  IF (SQL%NOTFOUND) THEN
     RAISE INCIDENCIA_NO_TROBADA;
  END IF;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN INCIDENCIA_NO_TROBADA THEN
    p_sortida:='ERROR: incidencia no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR en esborrar - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/**************************************************
 * Nom procediment: PermisAcces_Inserir
 * Descripci:      insereix un nou perms d'accs
 **************************************************/
 PROCEDURE PermisAcces_Inserir (p_idPermis OUT PermisAcces.idPermis%TYPE, p_idZona IN PermisAcces.idZona%TYPE,
                                 p_nomEmpresa IN PermisAcces.nomEmpresa%TYPE, p_nomDelegacio IN PermisAcces.nomDelegacio%TYPE, p_ID IN PermisAcces.ID%TYPE,
                                 p_nomDepartament IN PermisAcces.nomDepartament%TYPE, p_horaInici IN PermisAcces.horaInici%TYPE, p_horaFi IN PermisAcces.horaFi%TYPE,
                                 p_sortida OUT VARCHAR2) IS
  cntZona        NUMBER;
  cntPersona     NUMBER;
  cntDepartament NUMBER;
  cntPermisAcces NUMBER;
  ZONA_NO_TROBADA EXCEPTION;
  PERSONA_NO_TROBADA EXCEPTION;
  DEPARTAMENT_NO_TROBAT EXCEPTION;
  PARAMETRES_INCORRECTES EXCEPTION;
  PERMISACCES_TROBAT EXCEPTION;
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  BEGIN
  vProcedureName := 'PermisAcces_Inserir';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  cntZona := 0;
  SELECT COUNT(1) INTO cntZona FROM ZONA where idZona = p_idZona and nomEmpresa = p_nomEmpresa
  AND nomDelegacio = p_nomDelegacio;
  IF (cntZona = 0) THEN
    RAISE ZONA_NO_TROBADA;
  END IF;
  IF ((p_ID IS NOT NULL) AND (p_nomDepartament IS NULL)) THEN
    cntPersona := 0;
    SELECT COUNT(1) INTO cntPersona FROM PERSONA where ID = p_ID;
    IF (cntPersona = 0) THEN
      RAISE PERSONA_NO_TROBADA;
    END IF;
    cntPermisAcces := 0;
    SELECT COUNT(1) INTO cntPermisAcces FROM PERMISACCES WHERE idZona = p_idZona AND nomEmpresa = p_nomEmpresa
      AND nomDelegacio = p_nomDelegacio AND ID = p_ID 
      AND p_horaInici >= horaInici AND p_horaFi <= horaFi;
    IF (cntPermisAcces > 0) THEN
      RAISE PERMISACCES_TROBAT;
    END IF;
  END IF;
  IF ((p_nomDepartament IS NOT NULL) AND (p_ID IS NULL) ) THEN
    cntDepartament := 0;
    SELECT COUNT(1) INTO cntDepartament FROM DEPARTAMENT where nomDepartament = p_nomDepartament 
    AND nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
    IF (cntDepartament = 0) THEN
      RAISE DEPARTAMENT_NO_TROBAT;
    END IF;
    cntPermisAcces := 0;
    SELECT COUNT(1) INTO cntPermisAcces FROM PERMISACCES WHERE idZona = p_idZona AND nomEmpresa = p_nomEmpresa
      AND nomDelegacio = p_nomDelegacio AND nomDepartament = p_nomDepartament  
      AND p_horaInici >= horaInici AND p_horaFi <= horaFi;
    IF (cntPermisAcces > 0) THEN
      RAISE PERMISACCES_TROBAT;
    END IF;
  END IF;
  IF ((p_nomDepartament IS NULL) AND (p_ID IS NULL) ) THEN
    RAISE PARAMETRES_INCORRECTES;
  END IF;
  p_idPermis := SEQ_IDPERMIS.nextval;
  INSERT INTO PERMISACCES(idPermis, idZona, nomEmpresa, nomDelegacio, ID, 
    nomDepartament, horaInici, horaFi) 
  VALUES (p_idPermis, p_idZona, p_nomEmpresa, p_nomDelegacio, p_ID, 
    p_nomDepartament, p_horaInici, p_horaFi);
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN ZONA_NO_TROBADA THEN
    p_sortida:='ERROR: zona no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN PERSONA_NO_TROBADA THEN
    p_sortida:='ERROR: persona no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN DEPARTAMENT_NO_TROBAT THEN
    p_sortida:='ERROR: departament no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN PARAMETRES_INCORRECTES THEN
    p_sortida:='ERROR: parametres incorrectes - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN PERMISACCES_TROBAT THEN
    p_sortida:='ERROR: permisacces existent - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN DUP_VAL_ON_INDEX THEN
    p_sortida:='ERROR: permisacces existent - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR en inserir - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/****************************************************************
 * Nom procediment: PermisAcces_LlistatZona
 * Descripci:      obt el llistat de permisos d'accs per zona
 ****************************************************************/
PROCEDURE PermisAcces_LlistatZona(p_idZona IN PermisAcces.idZona%TYPE, p_nomEmpresa IN PermisAcces.nomEmpresa%TYPE, p_nomDelegacio IN PermisAcces.nomDelegacio%TYPE, 
                                  p_LlistatPermisAccesZona OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  cntZona NUMBER;
  ZONA_NO_PERMISACCES EXCEPTION;
  BEGIN
  vProcedureName := 'PermisAcces_LlistatZona';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  
  SELECT COUNT(1) INTO cntZona FROM PERMISACCES WHERE idZona = p_idZona AND nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  IF (cntZona = 0) THEN
    RAISE ZONA_NO_PERMISACCES;
  END IF;
  
  OPEN p_LlistatPermisAccesZona FOR
    SELECT * FROM PERMISACCES WHERE idZona = p_idZona AND nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN ZONA_NO_PERMISACCES THEN
    p_sortida:='ERROR: permisacces zona no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/*******************************************************************
 * Nom procediment: PermisAcces_LlistatPersona
 * Descripci:      obt el llistat de permisos d'accs per persona
 *******************************************************************/
PROCEDURE PermisAcces_LlistatPersona (p_ID IN PermisAcces.ID%TYPE, p_LlistatPermisAccesPersona OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  cntPersona NUMBER;
  PERSONA_NO_PERMISACCES EXCEPTION;
  BEGIN
  vProcedureName := 'PermisAcces_LlistatPersona';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  
  SELECT COUNT(1) INTO cntPersona FROM PERMISACCES WHERE ID = p_ID;
  IF (cntPersona = 0) THEN
    RAISE PERSONA_NO_PERMISACCES;
  END IF;
  
  OPEN p_LlistatPermisAccesPersona FOR
    SELECT * FROM PERMISACCES WHERE ID = p_ID;
  
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN PERSONA_NO_PERMISACCES THEN
    p_sortida:='ERROR: permisacces persona no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/***********************************************************************
 * Nom procediment: PermisAcces_LlistatDepartament
 * Descripci:      obt el llistat de permisos d'accs per departament
 ***********************************************************************/
PROCEDURE PermisAcces_LlistatDepartament (p_nomDepartament IN PermisAcces.nomDepartament%TYPE, p_nomEmpresa IN PermisAcces.nomEmpresa%TYPE, p_nomDelegacio IN PermisAcces.nomDelegacio%TYPE,
                                          p_LlistatPermisAccesDpt OUT SYS_REFCURSOR, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  cntDepartament NUMBER;
  DEPARTAMENT_NO_PERMISACCES EXCEPTION;
  BEGIN
  vProcedureName := 'PermisAcces_LlistatDepartament';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  
  SELECT COUNT(1) INTO cntDepartament FROM PERMISACCES WHERE nomDepartament = p_nomDepartament AND nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  IF (cntDepartament = 0) THEN
    RAISE DEPARTAMENT_NO_PERMISACCES;
  END IF;
  
  OPEN p_LlistatPermisAccesDpt FOR
    SELECT * FROM PERMISACCES WHERE nomDepartament = p_nomDepartament AND nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
  
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN DEPARTAMENT_NO_PERMISACCES THEN
    p_sortida:='ERROR: permisacces departament no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/*****************************************************************************
 * Nom procediment: PermisAcces_Esborrar
 * Descripci:      elimina un perms d'accs segons departament o persona
 *                  passats com a parmetre
 *****************************************************************************/
 PROCEDURE PermisAcces_Esborrar (p_idZona IN PermisAcces.idZona%TYPE,
                                 p_nomEmpresa IN PermisAcces.nomEmpresa%TYPE, p_nomDelegacio IN PermisAcces.nomDelegacio%TYPE, p_ID IN PermisAcces.ID%TYPE,
                                 p_nomDepartament IN PermisAcces.nomDepartament%TYPE, p_sortida OUT VARCHAR2) IS
  cntZona        NUMBER;
  cntPersona     NUMBER;
  cntDepartament NUMBER;
  ZONA_NO_TROBADA EXCEPTION;
  PERSONA_NO_TROBADA EXCEPTION;
  DEPARTAMENT_NO_TROBAT EXCEPTION;
  PARAMETRES_INCORRECTES EXCEPTION;
  PERMISACCES_NO_TROBAT EXCEPTION;
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  BEGIN
  vProcedureName := 'PermisAcces_Esborrar';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  IF ( (p_ID IS NULL) AND (p_nomDepartament IS NULL) ) THEN
      RAISE PARAMETRES_INCORRECTES;
  END IF;
  cntZona := 0;
  SELECT COUNT(1) INTO cntZona FROM ZONA where idZona = p_idZona and nomEmpresa = p_nomEmpresa
    AND nomDelegacio = p_nomDelegacio;
  IF (cntZona = 0) THEN
    RAISE ZONA_NO_TROBADA;
  END IF;
  IF ( (p_ID IS NOT NULL) AND (p_nomDepartament IS NULL) ) THEN
    cntPersona := 0;
    SELECT COUNT(1) INTO cntPersona FROM PERSONA where ID = p_ID;
    IF (cntPersona = 0) THEN
      RAISE PERSONA_NO_TROBADA;
    END IF;
    DELETE FROM PERMISACCES WHERE idZona = p_idZona AND ID = p_ID AND
      nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio; 
    IF (SQL%NOTFOUND) THEN
      RAISE PERMISACCES_NO_TROBAT;
    END IF;
  END IF;
  IF ( (p_nomDepartament IS NOT NULL) AND (p_ID IS NULL) ) THEN
    cntDepartament := 0;
    SELECT COUNT(1) INTO cntDepartament FROM DEPARTAMENT where nomDepartament = p_nomDepartament 
      AND nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio;
    IF (cntDepartament = 0) THEN
      RAISE DEPARTAMENT_NO_TROBAT;
    END IF;
    DELETE FROM PERMISACCES WHERE idZona = p_idZona AND nomDepartament = p_nomDepartament AND
      nomEmpresa = p_nomEmpresa AND nomDelegacio = p_nomDelegacio; 
    IF (SQL%NOTFOUND) THEN
      RAISE PERMISACCES_NO_TROBAT;
    END IF;
  END IF;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN ZONA_NO_TROBADA THEN
    p_sortida:='ERROR: zona no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  
  WHEN PERSONA_NO_TROBADA THEN
    p_sortida:='ERROR: persona no trobada - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  
  WHEN DEPARTAMENT_NO_TROBAT THEN
    p_sortida:='ERROR: departament no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
 
  WHEN PARAMETRES_INCORRECTES THEN
    p_sortida:='ERROR: parmetres incorrectes - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  
  WHEN PERMISACCES_NO_TROBAT THEN
    p_sortida:='ERROR: permisacces no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  
   WHEN OTHERS THEN
    p_sortida:='ERROR en esborrar - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;

/*************************************************************************
 * Nom procediment: PermisAcces_EsborrarPK
 * Descripci:      elimina un permis d'accs a partir de l'identificador
 *************************************************************************/
PROCEDURE PermisAcces_EsborrarPK(p_idPermis IN PermisAcces.idPermis%TYPE, p_sortida OUT VARCHAR2) IS
  status    VARCHAR2(50 CHAR);
  vDebugProc VARCHAR2(50 CHAR);
  vProcedureName VARCHAR2(30);
  PERMISACCES_NO_TROBAT EXCEPTION;
  BEGIN
  vProcedureName := 'PermisAcces_EsborrarPK';
  p_sortida := 'OK';
  VDebugProc := $$PLSQL_UNIT;
  DBMS_OUTPUT.PUT_LINE(VDebugProc);
  DELETE FROM PERMISACCES WHERE idPermis = p_idPermis;
  IF (SQL%NOTFOUND) THEN
     RAISE PERMISACCES_NO_TROBAT;
  END IF;
  INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
         VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, p_sortida);
EXCEPTION
  WHEN PERMISACCES_NO_TROBAT THEN
    p_sortida:='ERROR: permisacces no trobat - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK; 
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
  WHEN OTHERS THEN
    p_sortida:='ERROR en esborrar - Line '||$$PLSQL_LINE||' Error:'||SQLCODE||'-'||SUBSTR(SQLERRM, 1, 100);
    DBMS_OUTPUT.PUT_LINE(p_sortida);
    DBMS_OUTPUT.PUT_LINE(VDebugProc||'.'||vProcedureName);
    ROLLBACK;
    INSERT INTO LOGBD(IdLog, IdProcediment, DataExecucio, Sortida)
           VALUES(SEQ_LOGID.nextval, vDebugProc||'.'||vProcedureName, SYSDATE, substr(p_sortida,1,150));
END;
 
END Seguretat;
/
