set serveroutput on
alter session set nls_date_format = 'DD-MM-YYYY HH24:MI:SS';
VAR status2 VARCHAR2(100);
VAR rc refcursor; 

-- Taula: PAIS
-- Test U01_01
-- Procediment: Pais_Llistat
-- Descripci: obt el llistat (buit) de pasos (cap pas donat d'alta)
-- Estat: OK
exec ADMINISTRADOR.Pais_Llistat(:rc, :status2);
commit;
print status2;
print rc;
-- Test U02_01
-- Procediment Pais_Inserir
-- Descripci: insereix nou pas
-- Estat: OK
exec ADMINISTRADOR.Pais_Inserir('Espanya', :status2);
commit;
print status2;
-- Test U02_02
-- Procediment Pais_Inserir
-- Descripci: insereix nou pas
-- Estat: OK
exec ADMINISTRADOR.Pais_Inserir('Frana', :status2);
commit;
print status2;
-- Test U02_03
-- Procediment Pais_Inserir
-- Descripci: insereix nou pas
-- Estat: OK
exec ADMINISTRADOR.Pais_Inserir('Andorra', :status2);
commit;
print status2;
-- Test U02_04
-- Procediment Pais_Inserir
-- Descripci: insereix nou pas
-- Estat: OK
exec ADMINISTRADOR.Pais_Inserir('Portugal', :status2);
commit;
print status2;
-- Test U02_05
-- Procediment Pais_Inserir
-- Descripci: insereix nou pas
-- Estat: OK
exec ADMINISTRADOR.Pais_Inserir('Sucia', :status2);
commit;
print status2;
-- Test U02_06
-- Procediment Pais_Inserir
-- Descripci: insereix nou pas
-- Estat: OK
exec ADMINISTRADOR.Pais_Inserir('Brasil', :status2);
commit;
print status2;
-- Test U02_07
-- Procediment Pais_Inserir
-- Descripci: insereix pas existent
-- Estat: ERROR: pas existent
exec ADMINISTRADOR.Pais_Inserir('Frana', :status2);
commit;
print status2;
-- Test U03_01
-- Procediment Pais_Esborrar 
-- Descripci: elimina un pas existent
-- Estat: OK
exec ADMINISTRADOR.Pais_Esborrar('Sucia', :status2);
commit;
print status2;
-- Test U03_02
-- Procediment Pais_Esborrar 
-- Descripci: elimina un pas inexistent
-- Estat: ERROR: pas no trobat
exec ADMINISTRADOR.Pais_Esborrar('Sucia', :status2);
commit;
print status2;
-- Test U01_02
-- Procediment: Pais_Llistat
-- Descripci: obt el llistat de pasos, 5 pasos existents
-- Estat: OK
exec ADMINISTRADOR.Pais_Llistat(:rc, :status2);
commit;
print status2;
print rc;

------------------------------------------------------------------
-- Taula: CIUTAT
-- Test U04_01
-- Procediment: Ciutat_Llistat
-- Descripci: obt el llistat (buit) de ciutats (cap ciutat donada d'alta)
-- Estat: OK
exec ADMINISTRADOR.Ciutat_Llistat(:rc, :status2);
commit;
print status2;
print rc;
-- Test U05_01
-- Procediment: Ciutat_Inserir
-- Descripci: inserir nova ciutat
-- Estat: OK
exec ADMINISTRADOR.Ciutat_Inserir('Barcelona', 'Espanya', :status2);
commit;
print status2;
-- Test U05_02
-- Procediment: Ciutat_Inserir
-- Descripci: inserir nova ciutat
-- Estat: OK
exec ADMINISTRADOR.Ciutat_Inserir('Barcelona', 'Brasil', :status2);
commit;
print status2;
-- Test U05_03
-- Procediment: Ciutat_Inserir
-- Descripci: inserir nova ciutat
-- Estat: OK
exec ADMINISTRADOR.Ciutat_Inserir('Madrid', 'Espanya', :status2);
commit;
print status2;
-- Test U05_04
-- Procediment: Ciutat_Inserir
-- Descripci: inserir nova ciutat
-- Estat: OK
exec ADMINISTRADOR.Ciutat_Inserir('Pars', 'Frana', :status2);
commit;
print status2;
-- Test U05_05
-- Procediment: Ciutat_Inserir
-- Descripci: inserir nova ciutat, pas inexistent
-- Estat: ERROR: pas no trobat
exec ADMINISTRADOR.Ciutat_Inserir('Estocolm', 'Sucia', :status2);
commit;
print status2;
-- Test U05_06
-- Procediment: Ciutat_Inserir
-- Descripci: inserir ciutat existent
-- Estat: ERROR: ciutat existent
exec ADMINISTRADOR.Ciutat_Inserir('Barcelona', 'Espanya', :status2);
commit;
print status2;
-- Test U06_01
-- Procediment: Ciutat_Esborrar
-- Descripci: elimina una ciutat existent
-- Estat: OK
exec ADMINISTRADOR.Ciutat_Esborrar('Barcelona', 'Brasil', :status2);
commit;
print status2;
-- Test U06_02
-- Procediment: Ciutat_Esborrar
-- Descripci: elimina una ciutat inexistent
-- Estat: ERROR: ciutat no trobada
exec ADMINISTRADOR.Ciutat_Esborrar('Barcelona', 'Brasil', :status2);
commit;
print status2;
-- Test U04_02
-- Procediment: Ciutat_Llistat
-- Descripci: obt el llistat de ciutats (3 ciutats existents)
-- Estat: OK
exec ADMINISTRADOR.Ciutat_Llistat(:rc, :status2);
commit;
print status2;
print rc;

------------------------------------------------------------------
-- Taula: EMPRESA
-- Test U07_01
-- Procediment: Empresa_Llistat
-- Descripci: obt el llistat (buit) d'empreses (cap empresa donada d'alta)
-- Estat: OK
exec ADMINISTRADOR.Empresa_Llistat(:rc, :status2);
commit;
print status2;
print rc;
-- Test U08_01
-- Procediment Empresa_Inserir
-- Descripci: insereix nova empresa
-- Estat: OK
exec ADMINISTRADOR.Empresa_Inserir('Foods1', :status2);
commit;
print status2;
-- Test U08_02
-- Procediment Empresa_Inserir
-- Descripci: insereix nova empresa
-- Estat: OK
exec ADMINISTRADOR.Empresa_Inserir('Transports1', :status2);
commit;
print status2;
-- Test U08_03
-- Procediment Empresa_Inserir
-- Descripci: insereix nova empresa
-- Estat: OK
exec ADMINISTRADOR.Empresa_Inserir('Serveis1', :status2);
commit;
print status2;
-- Test U08_04
-- Procediment Empresa_Inserir
-- Descripci: insereix nova empresa
-- Estat: OK
exec ADMINISTRADOR.Empresa_Inserir('Premsa1', :status2);
commit;
print status2;
-- Test U08_05
-- Procediment Empresa_Inserir
-- Descripci: insereix nova empresa
-- Estat: OK
exec ADMINISTRADOR.Empresa_Inserir('Premsa2', :status2);
commit;
print status2;
-- Test U08_06
-- Procediment Empresa_Inserir
-- Descripci: insereix empresa existent
-- Estat: ERROR: empresa existent
exec ADMINISTRADOR.Empresa_Inserir('Premsa1', :status2);
commit;
print status2;
-- Test U09_01
-- Procediment Empresa_Esborrar 
-- Descripci: elimina una empresa existent
-- Estat: OK
exec ADMINISTRADOR.Empresa_Esborrar('Premsa2', :status2);
commit;
print status2;
-- Test U09_02
-- Procediment Empresa_Esborrar 
-- Descripci: elimina una empresa inexistent
-- Estat: ERROR: empresa no trobada
exec ADMINISTRADOR.Empresa_Esborrar('Premsa2', :status2);
commit;
print status2;
-- Test U07_02
-- Procediment: Empresa_Llistat
-- Descripci: obt el llistat d'empreses (4 empreses existents)
-- Estat: OK
exec ADMINISTRADOR.Empresa_Llistat(:rc, :status2);
commit;
print status2;
print rc;

------------------------------------------------------------------
-- Taula: DELEGACIO
-- Test U10_01
-- Procediment: Delegacio_Llistat
-- Descripci: obt el llistat (buit) de delegacions (cap delegaci donada d'alta)
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Llistat(:rc, :status2);
commit;
print status2;
print rc;
-- Test U11_01
-- Procediment: Delegacio_Inserir
-- Descripci: inserir nova delegaci
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Inserir('Foods1', 'Barcelona Nord', 'Avda. Diagonal, 606', '08010', 'Barcelona', 'Espanya', '933060000', :status2);
commit;
print status2;
-- Test U11_02
-- Procediment: Delegacio_Inserir
-- Descripci: inserir nova delegaci
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Inserir('Foods1', 'Barcelona Sud', 'Plaa Glories, 1', '08228', 'Barcelona', 'Espanya', '934070000', :status2);
commit;
print status2;
-- Test U11_03
-- Procediment: Delegacio_Inserir
-- Descripci: inserir nova delegaci
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Inserir('Serveis1', 'Barcelona Nord', 'Avda. Diagonal, 607', '08010', 'Barcelona', 'Espanya', '933070000', :status2);
commit;
print status2;
-- Test U11_04
-- Procediment: Delegacio_Inserir
-- Descripci: inserir nova delegaci
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Inserir('Premsa1', 'Barcelona Nord', 'Avda. Diagonal, 610', '08010', 'Barcelona', 'Espanya', '933071000', :status2);
commit;
print status2;
-- Test U11_05
-- Procediment: Delegacio_Inserir
-- Descripci: inserir nova delegaci
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Inserir('Premsa1', 'Barcelona Sud', 'Plaa Glories, 3', '08228', 'Barcelona', 'Espanya', '933061000', :status2);
commit;
print status2;
-- Test U11_06
-- Procediment: Delegacio_Inserir
-- Descripci: inserir delegaci existent
-- Estat: ERROR: delegaci existent
exec ADMINISTRADOR.Delegacio_Inserir('Premsa1', 'Barcelona Sud', 'Plaa Glories, 3', '08228', 'Barcelona', 'Espanya', '933061000', :status2);
commit;
print status2;
-- Test U11_07
-- Procediment: Delegacio_Inserir
-- Descripci: inserir nova delegaci, empresa inexistent
-- Estat: ERROR: empresa no trobada
exec ADMINISTRADOR.Delegacio_Inserir('Pets1', 'Barcelona Nord', 'Avda. Diagonal, 612', '08010', 'Barcelona', 'Espanya', '933060000', :status2);
commit;
print status2;
-- Test U11_08
-- Procediment: Delegacio_Inserir
-- Descripci: inserir nova delegaci, ciutat inexistent
-- Estat: ERROR: ciutat no trobada
exec ADMINISTRADOR.Delegacio_Inserir('Foods1', 'Reus zona', 'Plaa Prim, 1', '43202', 'Reus', 'Espanya', '973310000', :status2);
commit;
print status2;
-- Test U12_01
-- Procediment: Delegacio_Actualitzar
-- Descripci: actualitzar delegaci existent
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Actualitzar('Foods1', 'Barcelona Nord', 'Carrer de Jordi Girona, 8', '08034', 'Barcelona', 'Espanya', '933401000', :status2);
commit;
print status2;
-- Test U12_02
-- Procediment: Delegacio_Actualitzar
-- Descripci: actualitzar delegaci, empresa inexistent
-- Estat: ERROR: empresa no trobada
exec ADMINISTRADOR.Delegacio_Actualitzar('Pets1', 'Barcelona Nord', 'Avda. Diagonal, 612', '08010', 'Barcelona', 'Espanya', '933060000', :status2);
commit;
print status2;
-- Test U12_03
-- Procediment: Delegacio_Actualitzar
-- Descripci: actualitzar delegaci, ciutat inexistent
-- Estat: ERROR: ciutat no trobada
exec ADMINISTRADOR.Delegacio_Actualitzar('Foods1', 'Reus zona', 'Plaa Prim, 1', '43202', 'Reus', 'Espanya', '973310000', :status2);
commit;
print status2;
-- Test U12_04
-- Procediment: Delegacio_Actualitzar
-- Descripci: actualitzar delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec ADMINISTRADOR.Delegacio_Actualitzar('Premsa1', 'Barcelona Centre', 'Passeig de Grcia, 10', '08020', 'Barcelona', 'Espanya', '933301000', :status2);
commit;
print status2;
-- Test U13_01
-- Procediment: Delegacio_Consulta
-- Descripci: consultar delegaci existent
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Consulta('Foods1', 'Barcelona Nord', :rc, :status2);
commit;
print status2;
print rc;
-- Test U13_02
-- Procediment: Delegacio_Consulta
-- Descripci: consultar delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec ADMINISTRADOR.Delegacio_Consulta('Premsa1', 'Barcelona Centre', :rc, :status2);
commit;
print status2;
print rc;
-- Test U14_01
-- Procediment: Delegacio_Esborrar
-- Descripci: elimina una delegaci existent
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Esborrar('Premsa1', 'Barcelona Sud', :status2);
commit;
print status2;
-- Test U14_02
-- Procediment: Delegacio_Esborrar
-- Descripci: elimina una delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec ADMINISTRADOR.Delegacio_Esborrar('Premsa1', 'Barcelona Centre', :status2);
commit;
print status2;
-- Test U10_02
-- Procediment: Delegacio_Llistat
-- Descripci: obt el llistat delegacions (4 delegacions existents)
-- Estat: OK
exec ADMINISTRADOR.Delegacio_Llistat(:rc, :status2);
commit;
print status2;
print rc;

------------------------------------------------------------------
-- Taula: ZONA
-- Test U15_01
-- Procediment: Zona_Llistat
-- Descripci: obt el llistat (buit) de zones (cap zona donada d'alta)
-- Estat: OK
exec ADMINISTRADOR.Zona_Llistat(:rc, :status2);
commit;
print status2;
print rc;
-- Test U16_01
-- Procediment: Zona_Inserir
-- Descripci: inserir nova zona
-- Estat: OK
exec ADMINISTRADOR.Zona_Inserir('Planta baixa', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U16_02
-- Procediment: Zona_Inserir
-- Descripci: inserir nova zona
-- Estat: OK
exec ADMINISTRADOR.Zona_Inserir('Planta primera', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U16_03
-- Procediment: Zona_Inserir
-- Descripci: inserir nova zona
-- Estat: OK
exec ADMINISTRADOR.Zona_Inserir('Oficines', 'Serveis1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U16_04
-- Procediment: Zona_Inserir
-- Descripci: inserir nova zona
-- Estat: OK
exec ADMINISTRADOR.Zona_Inserir('Laboratori', 'Serveis1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U16_05
-- Procediment: Zona_Inserir
-- Descripci: inserir nova zona
-- Estat: OK
exec ADMINISTRADOR.Zona_Inserir('Planta segona', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U16_06
-- Procediment: Zona_Inserir
-- Descripci: inserir nova zona, delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec ADMINISTRADOR.Zona_Inserir('Laboratori', 'Pets1', 'Barcelona Sud', :status2);
commit;
print status2;
-- Test U16_07
-- Procediment: Zona_Inserir
-- Descripci: inserir zona existent
-- Estat: ERROR: zona existent
exec ADMINISTRADOR.Zona_Inserir('Planta baixa', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U17_01
-- Procediment: Zona_Esborrar
-- Descripci: elimina una zona existent
-- Estat: OK
exec ADMINISTRADOR.Zona_Esborrar('Planta baixa', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U17_02
-- Procediment: Zona_Esborrar
-- Descripci: elimina una zona inexistent
-- Estat: ERROR: zona no trobada
exec ADMINISTRADOR.Zona_Esborrar('Planta baixa', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U15_02
-- Procediment: Zona_Llistat
-- Descripci: obt el llistat de zones (3 zones existents)
-- Estat: OK
exec ADMINISTRADOR.Zona_Llistat(:rc, :status2);
commit;
print status2;
print rc;

------------------------------------------------------------------
-- Taula: DEPARTAMENT
-- Test U18_01
-- Procediment: Departament_Llistat
-- Descripci: obt el llistat (buit) de departaments (cap departament donat d'alta)
-- Estat: OK
exec ADMINISTRADOR.Departament_Llistat(:rc, :status2);
commit;
print status2;
print rc;
-- Test U19_01
-- Procediment: Departament_Inserir
-- Descripci: inserir nou departament
-- Estat: OK
exec ADMINISTRADOR.Departament_Inserir('Direcci', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U19_02
-- Procediment: Departament_Inserir
-- Descripci: inserir nou departament
-- Estat: OK
exec ADMINISTRADOR.Departament_Inserir('Informtica', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U19_03
-- Procediment: Departament_Inserir
-- Descripci: inserir nou departament
-- Estat: OK
exec ADMINISTRADOR.Departament_Inserir('Administraci', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U19_04
-- Procediment: Departament_Inserir
-- Descripci: inserir nou departament
-- Estat: OK
exec ADMINISTRADOR.Departament_Inserir('Administraci', 'Serveis1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U19_05
-- Procediment: Departament_Inserir
-- Descripci: inserir nou departament
-- Estat: OK
exec ADMINISTRADOR.Departament_Inserir('Direcci', 'Serveis1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U19_06
-- Procediment: Departament_Inserir
-- Descripci: inserir nou departament, delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec ADMINISTRADOR.Departament_Inserir('Administraci', 'Pets1', 'Barcelona Sud', :status2);
commit;
print status2;
-- Test U19_07
-- Procediment: Departament_Inserir
-- Descripci: inserir departament existent
-- Estat: ERROR: departament existent
exec ADMINISTRADOR.Departament_Inserir('Administraci', 'Serveis1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U20_01
-- Procediment: Departament_Esborrar
-- Descripci: elimina un departament existent
-- Estat: OK
exec ADMINISTRADOR.Departament_Esborrar('Administraci', 'Serveis1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U20_02
-- Procediment: Departament_Esborrar
-- Descripci: elimina un departament inexistent
-- Estat: ERROR: departament no trobat
exec ADMINISTRADOR.Departament_Esborrar('Administraci', 'Serveis1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U18_02
-- Procediment: Departament_Llistat
-- Descripci: obt el llistat de departaments (4 departaments existents)
-- Estat: OK
exec ADMINISTRADOR.Departament_Llistat(:rc, :status2);
commit;
print status2;
print rc;
