set serveroutput on
alter session set nls_date_format = 'DD-MM-YYYY HH24:MI:SS';
VAR status2 VARCHAR2(100);
VAR rc refcursor; 

------------------------------------------------------------------
-- Taula: PERSONA
-- Test U21_01
-- Procediment: Persona_Llistat
-- Descripci: obt el llistat (buit) de persones (cap persona donada d'alta)
-- Estat: OK
exec PERSONAL.Persona_Llistat(:rc, :status2);
commit;
print status2;
print rc;
-- Test U22_01
-- Procediment: Persona_Inserir
-- Descripci: inserir nova persona
-- Estat: OK
exec PERSONAL.Persona_Inserir('44303923N', 'Pere', 'Mart Puig', '12-07-1969', '600900700', 'H', :status2);
commit;
print status2;
-- Test U22_02
-- Procediment: Persona_Inserir
-- Descripci: inserir nova persona
-- Estat: OK
exec PERSONAL.Persona_Inserir('45233567L', 'Maria', 'Sard Pera', '23-04-1977', '600989767', 'M', :status2);
commit;
print status2;
-- Test U22_03
-- Procediment: Persona_Inserir
-- Descripci: inserir nova persona
-- Estat: OK
exec PERSONAL.Persona_Inserir('46358419X', 'Joan', 'Maci Salat', '12-03-1974', '600898300', 'H', :status2);
commit;
print status2;
-- Test U22_04
-- Procediment: Persona_Inserir
-- Descripci: inserir nova persona
-- Estat: OK
exec PERSONAL.Persona_Inserir('47575632V', 'Jacint', 'Forcades Pujol', '01-09-1983', '610900878', 'H', :status2);
commit;
print status2;
-- Test U22_05
-- Procediment: Persona_Inserir
-- Descripci: inserir nova persona
-- Estat: OK
exec PERSONAL.Persona_Inserir('47710243D', 'Josep', 'Moles Marn', '01-09-1984', '616788989', 'H', :status2);
commit;
print status2;
-- Test U22_06
-- Procediment: Persona_Inserir
-- Descripci: inserir nova persona
-- Estat: OK
exec PERSONAL.Persona_Inserir('477201102T', 'Alba', 'Garcia Moratinos', '21-10-1984', '616778899', 'M', :status2);
commit;
print status2;
-- Test U22_07
-- Procediment: Persona_Inserir
-- Descripci: inserir nova persona
-- Estat: ERROR: persona existent
exec PERSONAL.Persona_Inserir('47575632V', 'Jacint', 'Forcades Pujol', '01-09-1983', '610900878', 'H', :status2);
commit;
print status2;
-- Test U22_08
-- Procediment: Persona_Inserir
-- Descripci: inserir nova persona, camp sexe valor incorrecte
-- Estat: ERROR: error en inserir - check constraint CKPERSONA_SEXE violated 
exec PERSONAL.Persona_Inserir('47678721C', 'Daniel', 'Mateu Moles', '28-02-1982', '629008788', 'F', :status2);
commit;
print status2;
-- Test U23_01
-- Procediment: Persona_Actualitzar
-- Descripci: actualitzar persona existent
-- Estat: OK
exec PERSONAL.Persona_Actualitzar('44303923N', 'Pere', 'Mart Puig', '12-07-1969', '616324765', 'H', :status2);
commit;
print status2;
-- Test U23_02
-- Procediment: Persona_Actualitzar
-- Descripci: actualitzar persona inexistent
-- Estat: ERROR: persona no trobada
exec PERSONAL.Persona_Actualitzar('44923354F', 'Pere', 'Mart Puig', '12-07-1969', '619878345', 'H', :status2);
commit;
print status2;
-- Test U24_01
-- Procediment: Persona_Consulta
-- Descripci: consultar persona existent
-- Estat: OK
exec PERSONAL.Persona_Consulta('44303923N', :rc, :status2);
commit;
print status2;
print rc;
-- Test U24_02
-- Procediment: Persona_Consulta
-- Descripci: consultar persona inexistent
-- Estat: ERROR: persona no trobada
exec PERSONAL.Persona_Consulta('44923354F', :rc, :status2);
commit;
print status2;
print rc;
-- Test U25_01
-- Procediment: Persona_Esborrar
-- Descripci: elimina una persona existent
-- Estat: OK
exec PERSONAL.Persona_Esborrar('44303923N', :status2);
commit;
print status2;
-- Test U25_02
-- Procediment: Persona_Esborrar
-- Descripci: elimina una persona inexistent
-- Estat: ERROR: persona no trobada
exec PERSONAL.Persona_Esborrar('44303923N', :status2);
commit;
print status2;
-- Test U22_09
-- Procediment: Persona_Inserir
-- Descripci: inserir nova persona
-- Estat: OK
exec PERSONAL.Persona_Inserir('44303923N', 'Pere', 'Mart Puig', '12-07-1969', '600900700', 'H', :status2);
commit;
print status2;
-- Test U21_02
-- Procediment: Persona_Llistat
-- Descripci: obt el llistat de persones (6 persones donades d'alta)
-- Estat: OK
exec PERSONAL.Persona_Llistat(:rc, :status2);
commit;
print status2;
print rc;

------------------------------------------------------------------
-- Taula: EMPLEAT
-- Test U26_01
-- Procediment: Empleat_Llistat
-- Descripci: obt el llistat (buit) d'empleats (cap empleat donat d'alta)
-- Estat: OK
exec PERSONAL.Empleat_Llistat(:rc, :status2);
commit;
print status2;
print rc;
-- Test U27_01
-- Procediment: Empleat_Inserir
-- Descripci: inserir nou empleat
-- Estat: OK
exec PERSONAL.Empleat_Inserir('45233567L', '100', 'Direcci', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U27_02
-- Procediment: Empleat_Inserir
-- Descripci: inserir nou empleat
-- Estat: OK
exec PERSONAL.Empleat_Inserir('46358419X', '101', 'Informtica', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U27_03
-- Procediment: Empleat_Inserir
-- Descripci: inserir nou empleat, persona inexistent
-- Estat: ERROR: persona no trobada
exec PERSONAL.Empleat_Inserir('48645762A', '102', 'Informtica', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U27_04
-- Procediment: Empleat_Inserir
-- Descripci: inserir nou empleat, departament inexistent
-- Estat: ERROR: departament no trobat
exec PERSONAL.Empleat_Inserir('46358419X', '102', 'RRHH', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U27_05
-- Procediment: Empleat_Inserir
-- Descripci: inserir nou empleat
-- Estat: OK
exec PERSONAL.Empleat_Inserir('47575632V', '102', 'Informtica', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U27_06
-- Procediment: Empleat_Inserir
-- Descripci: inserir nou empleat
-- Estat: OK
exec PERSONAL.Empleat_Inserir('44303923N', '100', 'Direcci', 'Serveis1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U27_07
-- Procediment: Empleat_Inserir
-- Descripci: inserir empleat existent
-- Estat: ERROR: empleat existent
exec PERSONAL.Empleat_Inserir('47575632V', '102', 'Informtica', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U28_01
-- Procediment: Empleat_Actualitzar
-- Descripci: actualitzar empleat existent
-- Estat: OK
exec PERSONAL.Empleat_Actualitzar('47575632V', '102', 'Administraci', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U28_02
-- Procediment: Empleat_Actualitzar
-- Descripci: actualitzar empleat inexistent
-- Estat: ERROR: empleat no trobat
exec PERSONAL.Empleat_Actualitzar('44303923N', '103', 'Administraci', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U28_03
-- Procediment: Empleat_Actualitzar
-- Descripci: actualitzar empleat existent, departament inexistent
-- Estat: ERROR: departament no trobat
exec PERSONAL.Empleat_Actualitzar('47575632V', '102', 'RRHH', 'Foods1', 'Barcelona Nord', :status2);
commit;
print status2;
-- Test U29_01
-- Procediment: Empleat_Consulta
-- Descripci: consultar empleat existent
-- Estat: OK
exec PERSONAL.Empleat_Consulta('45233567L', '100', :rc, :status2);
commit;
print status2;
print rc;
-- Test U29_02
-- Procediment: Empleat_Consulta
-- Descripci: consultar empleat inexistent
-- Estat: ERROR: empleat no trobat
exec PERSONAL.Empleat_Consulta('44923354F', '300', :rc, :status2);
commit;
print status2;
print rc;
-- Test U30_01
-- Procediment: Empleat_Esborrar
-- Descripci: elimina un empleat existent
-- Estat: OK
exec PERSONAL.Empleat_Esborrar('47575632V', '102', :status2);
commit;
print status2;
-- Test U30_02
-- Procediment: Empleat_Esborrar
-- Descripci: elimina un empleat inexistent
-- Estat: ERROR: empleat no trobat
exec PERSONAL.Empleat_Esborrar('47575632V', '102', :status2);
commit;
print status2;
-- Test U26_02
-- Procediment: Empleat_Llistat
-- Descripci: obt el llistat d'empleats (3 empleats existents)
-- Estat: OK
exec PERSONAL.Empleat_Llistat(:rc, :status2);
commit;
print status2;
print rc;

------------------------------------------------------------------
-- Taula: EXTERN
-- Test U31_01
-- Procediment: Extern_Llistat
-- Descripci: obt el llistat (buit) d'externs (cap extern donat d'alta)
-- Estat: OK
exec PERSONAL.Extern_Llistat(:rc, :status2);
commit;
print status2;
print rc;
-- Test U32_01
-- Procediment: Extern_Inserir
-- Descripci: inserir nou extern
-- Estat: OK
exec PERSONAL.Extern_Inserir('47710243D', 'Seguretat1', :status2);
commit;
print status2;
-- Test U32_02
-- Procediment: Extern_Inserir
-- Descripci: inserir nou extern
-- Estat: OK
exec PERSONAL.Extern_Inserir('477201102T', 'Seguretat1', :status2);
commit;
print status2;
-- Test U32_03
-- Procediment: Extern_Inserir
-- Descripci: inserir nou extern, persona inexistent
-- Estat: ERROR: persona no trobada
exec PERSONAL.Extern_Inserir('48645762A', 'Seguretat1', :status2);
commit;
print status2;
-- Test U32_04
-- Procediment: Extern_Inserir
-- Descripci: inserir extern existent
-- Estat: ERROR: extern existent
exec PERSONAL.Extern_Inserir('477201102T', 'Seguretat1', :status2);
commit;
print status2;
-- Test U33_01
-- Procediment: Extern_Esborrar
-- Descripci: elimina un extern existent
-- Estat: OK
exec PERSONAL.Extern_Esborrar('477201102T', 'Seguretat1', :status2);
commit;
print status2;
-- Test U33_02
-- Procediment: Extern_Esborrar
-- Descripci: elimina un extern inexistent
-- Estat: ERROR: extern no trobat
exec PERSONAL.Extern_Esborrar('477201102T', 'Seguretat1', :status2);
commit;
print status2;
-- Test U31_02
-- Procediment: Extern_Llistat
-- Descripci: obt el llistat d'externs (1 extern donat d'alta)
-- Estat: OK
exec PERSONAL.Extern_Llistat(:rc, :status2);
commit;
print status2;
print rc;
