set serveroutput on
alter session set nls_date_format = 'DD-MM-YYYY HH24:MI:SS';
VAR status2 VARCHAR2(100);
VAR rc refcursor; 
VAR idVisita NUMBER;
VAR idLliurament NUMBER;
VAR idIncidencia NUMBER;
VAR idPermisAcces NUMBER;

------------------------------------------------------------------
-- Taula: VISITA
-- Test U34_01
-- Procediment: Visita_Inserir
-- Descripci: inserir nova visita
-- Estat: OK
exec SEGURETAT.Visita_Inserir(:idVisita, 'Foods1', 'Barcelona Nord', '100', '45233567L', sysdate - 15/1440, sysdate - 15/1440, 'Auditoria', :status2);
commit;
print status2;
-- Test U34_02
-- Procediment: Visita_Inserir
-- Descripci: inserir nova visita
-- Estat: OK
exec SEGURETAT.Visita_Inserir(:idVisita, 'Foods1', 'Barcelona Nord', '101', '46358419X', sysdate - 15/1440, sysdate - 15/1440, 'Comercial', :status2);
commit;
print status2;
-- Test U34_03
-- Procediment: Visita_Inserir
-- Descripci: inserir nova visita
-- Estat: OK
exec SEGURETAT.Visita_Inserir(:idVisita, 'Serveis1', 'Barcelona Nord', '100', '44303923N', sysdate - 15/1440, sysdate - 15/1440, 'Auditoria', :status2);
commit;
print status2;
-- Test U34_04
-- Procediment: Visita_Inserir
-- Descripci: inserir nova visita, delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec SEGURETAT.Visita_Inserir(:idVisita, 'Serveis1', 'Barcelona Centre', '100', '44303923N', sysdate - 15/1440, sysdate - 15/1440, 'Auditoria', :status2);
commit;
print status2;
-- Test U34_05
-- Procediment: Visita_Inserir
-- Descripci: inserir nova visita, empleat inexistent
-- Estat: ERROR: empleat no trobat
exec SEGURETAT.Visita_Inserir(:idVisita, 'Serveis1', 'Barcelona Nord', '112', '44303923N', sysdate - 15/1440, sysdate - 15/1440, 'Auditoria', :status2);
commit;
print status2;
-- Test U35_01
-- Procediment: Visita_ActSortida
-- Descripci: actualitzar hora sortida visita existent
-- Estat: OK
exec SEGURETAT.Visita_ActSortida('Foods1', 'Barcelona Nord', '100', '45233567L', sysdate, :status2);
commit;
print status2;
-- Test U35_02
-- Procediment: Visita_ActSortida
-- Descripci: actualitzar hora sortida visita existent
-- Estat: OK
exec SEGURETAT.Visita_ActSortida('Foods1', 'Barcelona Nord', '101', '46358419X', sysdate, :status2);
commit;
print status2;
-- Test U35_03
-- Procediment: Visita_ActSortida
-- Descripci: actualitzar hora sortida visita existent
-- Estat: OK
exec SEGURETAT.Visita_ActSortida('Serveis1', 'Barcelona Nord', '100', '44303923N', sysdate, :status2);
commit;
print status2;
-- Test U35_04
-- Procediment: Visita_ActSortida
-- Descripci: actualitzar hora sortida, delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec SEGURETAT.Visita_ActSortida('Serveis1', 'Barcelona Centre', '100', '44303923N', sysdate, :status2);
commit;
print status2;
-- Test U35_05
-- Procediment: Visita_ActSortida
-- Descripci: actualitzar hora sortida, empleat inexistent
-- Estat: empleat no trobat
exec SEGURETAT.Visita_ActSortida('Serveis1', 'Barcelona Nord', '112', '44303923N', sysdate, :status2);
commit;
print status2;
-- Test U35_06
-- Procediment: Visita_ActSortida
-- Descripci: actualitzar hora sortida, visita inexistent
-- Estat: visita no trobada
exec SEGURETAT.Visita_ActSortida('Foods1', 'Barcelona Nord', '100', '44303923N', sysdate, :status2);
commit;
print status2;
-- Test U35_07
-- Procediment: Visita_ActSortida
-- Descripci: actualitzar hora sortida, visita ja actualitzada
-- Estat: visita ja actualitzada
exec SEGURETAT.Visita_ActSortida('Serveis1', 'Barcelona Nord', '100', '44303923N', sysdate, :status2);
commit;
print status2;
-- Test U36_01
-- Procediment: Visita_LlistatDelegacio
-- Descripci: obt el llistat de visites per delegaci
-- Estat: OK
exec SEGURETAT.Visita_LlistatDelegacio('Foods1', 'Barcelona Nord', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U36_02
-- Procediment: Visita_LlistatDelegacio
-- Descripci: obt el llistat de visites per delegaci, visita inexistent per delegaci
-- Estat: ERROR: visita delegaci no trobada
exec SEGURETAT.Visita_LlistatDelegacio('Premsa1', 'Barcelona Nord', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U36_03
-- Procediment: Visita_LlistatDelegacio
-- Descripci: obt el llistat de visites per delegaci
-- Estat: OK
exec SEGURETAT.Visita_LlistatDelegacio('Foods1', 'Barcelona Nord', sysdate - 2, sysdate - 1, :rc, :status2);
commit;
print status2;
print rc;
-- Test U37_01
-- Procediment: Visita_Esborrar
-- Descripci: elimina una visita existent segons identificador visita
-- Estat: OK
exec SEGURETAT.Visita_Esborrar('1', :status2);
commit;
print status2;
-- Test U37_02
-- Procediment: Visita_Esborrar
-- Descripci: elimina una visita inexistent segons identificador visita
-- Estat: visita no trobada
exec SEGURETAT.Visita_Esborrar('1', :status2);
commit;
print status2;
-- Test U38_01
-- Procediment: Visita_LlistatEmpleat
-- Descripci: obt el llistat de visites per empleat
-- Estat: OK
exec SEGURETAT.Visita_LlistatEmpleat('101', '46358419X', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U38_02
-- Procediment: Visita_LlistatEmpleat
-- Descripci: obt el llistat de visites per empleat, visita inexistent per empleat
-- Estat: ERROR: visita empleat no trobada
exec SEGURETAT.Visita_LlistatEmpleat('100', '45233567L', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U38_03
-- Procediment: Visita_LlistatEmpleat
-- Descripci: obt el llistat de visites per empleat
-- Estat: OK
exec SEGURETAT.Visita_LlistatEmpleat('101', '46358419X', sysdate - 2, sysdate - 1, :rc, :status2);
commit;
print status2;
print rc;

------------------------------------------------------------------
-- Taula: LLIURAMENT
-- Test U39_01
-- Procediment: Lliurament_Inserir
-- Descripci: inserir nou lliurament
-- Estat: OK
exec SEGURETAT.Lliurament_Inserir(:idLliurament, 'Foods1', 'Barcelona Nord', '100', '45233567L', sysdate - 15/1440, 'SEUR', :status2);
commit;
print status2;
-- Test U39_02
-- Procediment: Lliurament_Inserir
-- Descripci: inserir nou lliurament
-- Estat: OK
exec SEGURETAT.Lliurament_Inserir(:idLliurament, 'Foods1', 'Barcelona Nord', '101', '46358419X', sysdate - 15/1440, 'MRW', :status2);
commit;
print status2;
-- Test U39_03
-- Procediment: Lliurament_Inserir
-- Descripci: inserir nou lliurament
-- Estat: OK
exec SEGURETAT.Lliurament_Inserir(:idLliurament, 'Serveis1', 'Barcelona Nord', '100', '44303923N', sysdate - 15/1440, 'Envialia', :status2);
commit;
print status2;
-- Test U39_04
-- Procediment: Lliurament_Inserir
-- Descripci: inserir nou lliurament, delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec SEGURETAT.Lliurament_Inserir(:idLliurament, 'Serveis1', 'Barcelona Centre', '100', '44303923N', sysdate - 15/1440, 'Envialia', :status2);
commit;
print status2;
-- Test U39_05
-- Procediment: Lliurament_Inserir
-- Descripci: inserir nou lliurament, empleat inexistent
-- Estat: ERROR: empleat no trobat
exec SEGURETAT.Lliurament_Inserir(:idLliurament, 'Serveis1', 'Barcelona Nord', '112', '44303923N', sysdate - 15/1440, 'Envialia', :status2);
commit;
print status2;
-- Test U40_01
-- Procediment: Lliurament_LlistatDelegacio
-- Descripci: obt el llistat de lliuraments per delegaci
-- Estat: OK
exec SEGURETAT.Lliurament_LlistatDelegacio('Foods1', 'Barcelona Nord', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U40_02
-- Procediment: Lliurament_LlistatDelegacio
-- Descripci: obt el llistat de lliuraments per delegaci, lliurament inexistent per delegaci
-- Estat: lliurament delegaci no trobat
exec SEGURETAT.Lliurament_LlistatDelegacio('Premsa1', 'Barcelona Nord', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U40_03
-- Procediment: Lliurament_LlistatDelegacio
-- Descripci: obt el llistat de lliuraments per delegaci
-- Estat: OK
exec SEGURETAT.Lliurament_LlistatDelegacio('Foods1', 'Barcelona Nord', sysdate - 2, sysdate - 1, :rc, :status2);
commit;
print status2;
print rc;
-- Test U41_01
-- Procediment: Lliurament_Esborrar
-- Descripci: elimina un lliurament existent segons identificador lliurament
-- Estat: OK
exec SEGURETAT.Lliurament_Esborrar('1', :status2);
commit;
print status2;
-- Test U41_02
-- Procediment: Lliurament_Esborrar
-- Descripci: elimina un lliurament inexistent segons identificador lliurament
-- Estat: ERROR: lliurament no trobat
exec SEGURETAT.Lliurament_Esborrar('1', :status2);
commit;
print status2;
-- Test U42_01
-- Procediment: Lliurament_LlistatEmpleat
-- Descripci: obt el llistat de lliuraments per empleat
-- Estat: OK
exec SEGURETAT.Lliurament_LlistatEmpleat('101', '46358419X', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U42_02
-- Procediment: Lliurament_LlistatEmpleat
-- Descripci: obt el llistat de lliuraments per empleat, lliurament inexistent per empleat
-- Estat: ERROR: lliurament empleat no trobat
exec SEGURETAT.Lliurament_LlistatEmpleat('100', '45233567L', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U42_03
-- Procediment: Lliurament_LlistatEmpleat
-- Descripci: obt el llistat de lliuraments per empleat
-- Estat: OK
exec SEGURETAT.Lliurament_LlistatEmpleat('101', '46358419X', sysdate - 2, sysdate - 1, :rc, :status2);
commit;
print status2;
print rc;

------------------------------------------------------------------
-- Taula: INCIDENCIA
-- Test U43_01
-- Procediment: Incidencia_Inserir
-- Descripci: inserir nova incidencia
-- Estat: OK
exec SEGURETAT.Incidencia_Inserir(:idIncidencia, 'Foods1', 'Barcelona Nord', sysdate - 15/1440, 'Robatori', :status2);
commit;
print status2;
-- Test U43_02
-- Procediment: Incidencia_Inserir
-- Descripci: inserir nova incidencia
-- Estat: OK
exec SEGURETAT.Incidencia_Inserir(:idIncidencia, 'Foods1', 'Barcelona Nord', sysdate - 15/1440, 'Incendi', :status2);
commit;
print status2;
-- Test U43_03
-- Procediment: Incidencia_Inserir
-- Descripci: inserir nova incidencia
-- Estat: OK
exec SEGURETAT.Incidencia_Inserir(:idIncidencia, 'Serveis1', 'Barcelona Nord', sysdate - 15/1440, 'Robatori', :status2);
commit;
print status2;
-- Test U43_04
-- Procediment: Incidencia_Inserir
-- Descripci: inserir nova incidencia, delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec SEGURETAT.Incidencia_Inserir(:idIncidencia, 'Serveis1', 'Barcelona Centre', sysdate - 15/1440, 'Robatori', :status2);
commit;
print status2;
-- Test U44_01
-- Procediment: Incidencia_LlistatDelegacio
-- Descripci: obt el llistat d'incidncies (tots tipus) per delegaci
-- Estat: OK
exec SEGURETAT.Incidencia_LlistatDelegacio('Foods1', 'Barcelona Nord', '', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U44_02
-- Procediment: Incidencia_LlistatDelegacio
-- Descripci: obt el llistat d'incidncies (tipus 'Robatori') per delegaci
-- Estat: OK
exec SEGURETAT.Incidencia_LlistatDelegacio('Foods1', 'Barcelona Nord', 'Robatori', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U44_03
-- Procediment: Incidencia_LlistatDelegacio
-- Descripci: obt el llistat d'incidncies (tots tipus) per delegaci, incidncia inexistent per delegaci
-- Estat: ERROR: incidncia delegaci no trobada
exec SEGURETAT.Incidencia_LlistatDelegacio('Premsa1', 'Barcelona Nord', '', sysdate - 1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U44_04
-- Procediment: Incidencia_LlistatDelegacio
-- Descripci: obt el llistat d'incidncies (tots tipus) per delegaci
-- Estat: OK
exec SEGURETAT.Incidencia_LlistatDelegacio('Foods1', 'Barcelona Nord', '', sysdate - 2, sysdate - 1, :rc, :status2);
commit;
print status2;
print rc;
-- Test U45_01
-- Procediment: Incidencia_Esborrar
-- Descripci: elimina una incidncia existent segons identificador incidncia 
-- Estat: OK
exec SEGURETAT.Incidencia_Esborrar('1', :status2);
commit;
print status2;
-- Test U45_02
-- Procediment: Incidencia_Esborrar
-- Descripci: elimina una incidencia inexistent segons identificador incidncia
-- Estat: ERROR: incidncia no trobada
exec SEGURETAT.Incidencia_Esborrar('1', :status2);
commit;
print status2;

------------------------------------------------------------------
-- Taula: PERMISACCES
-- Test U46_01
-- Procediment: PermisAcces_Inserir
-- Descripci: inserir nou permisacces a zona per persona
-- Estat: OK
exec SEGURETAT.PermisAcces_Inserir(:idPermisAcces, 'Planta primera', 'Foods1', 'Barcelona Nord', '477201102T', NULL, sysdate, sysdate +1, :status2);
commit;
print status2;
-- Test U46_02
-- Procediment: PermisAcces_Inserir
-- Descripci: inserir nou permisacces a zona per persona
-- Estat: OK
exec SEGURETAT.PermisAcces_Inserir(:idPermisAcces, 'Planta primera', 'Foods1', 'Barcelona Nord', '47575632V', NULL, sysdate, sysdate +1, :status2);
commit;
print status2;
-- Test U46_03
-- Procediment: PermisAcces_Inserir
-- Descripci: inserir nou permisacces a zona per departament
-- Estat: OK
exec SEGURETAT.PermisAcces_Inserir(:idPermisAcces, 'Planta segona', 'Foods1', 'Barcelona Nord', NULL, 'Informtica', sysdate, sysdate+1, :status2);
commit;
print status2;
-- Test U46_04
-- Procediment: PermisAcces_Inserir
-- Descripci: inserir nou permisacces a zona per departament, zona inexistent
-- Estat: ERROR: zona no trobada
exec SEGURETAT.PermisAcces_Inserir(:idPermisAcces, 'Planta baixa', 'Foods1', 'Barcelona Nord', NULL, 'Informtica', sysdate, sysdate+1, :status2);
commit;
print status2;
-- Test U46_05
-- Procediment: PermisAcces_Inserir
-- Descripci: inserir nou permisacces per persona, persona inexistent
-- Estat: ERROR: persona no trobada
exec SEGURETAT.PermisAcces_Inserir(:idPermisAcces, 'Planta primera', 'Foods1', 'Barcelona Nord', '48645762A', NULL, sysdate, sysdate+1, :status2);
commit;
print status2;
-- Test U46_06
-- Procediment: PermisAcces_Inserir
-- Descripci: inserir nou permisacces a zona per departament, departament inexistent
-- Estat: ERROR: departament no trobat
exec SEGURETAT.PermisAcces_Inserir(:idPermisAcces, 'Planta segona', 'Foods1', 'Barcelona Nord', NULL, 'Gesti', sysdate, sysdate+1, :status2);
commit;
print status2;
-- Test U46_07
-- Procediment: PermisAcces_Inserir
-- Descripci: inserir nou perms accs a zona per departament, persona i departaments nulls
-- Estat: ERROR: parmetres incorrectes
exec SEGURETAT.PermisAcces_Inserir(:idPermisAcces, 'Planta segona', 'Foods1', 'Barcelona Nord', NULL, NULL, sysdate, sysdate+1, :status2);
commit;
print status2;
-- Test U46_08
-- Procediment: PermisAcces_Inserir
-- Descripci: inserir nou permisacces a zona per persona, permisacces existent
-- Estat: ERROR: permisacces existent
exec SEGURETAT.PermisAcces_Inserir(:idPermisAcces, 'Planta primera', 'Foods1', 'Barcelona Nord', '47575632V', NULL, sysdate, sysdate, :status2);
commit;
print status2;
-- Test U46_09
-- Procediment: PermisAcces_Inserir
-- Descripci: inserir nou permisacces a zona per departament, permisacces existent
-- Estat: ERROR: permisacces existent
exec SEGURETAT.PermisAcces_Inserir(:idPermisAcces, 'Planta segona', 'Foods1', 'Barcelona Nord', NULL, 'Informtica', sysdate, sysdate, :status2);
commit;
print status2;
-- Test U47_01
-- Procediment: PermisAcces_LlistatZona
-- Descripci: obt el llistat de permisos d'accs per zona
-- Estat: OK
exec SEGURETAT.PermisAcces_LlistatZona('Planta primera', 'Foods1', 'Barcelona Nord', :rc, :status2);
commit;
print status2;
print rc;
-- Test U47_02
-- Procediment: PermisAcces_LlistatZona
-- Descripci: obt el llistat de permisos d'accs per zona, perms inexistent per zona
-- Estat: ERROR: permisacces zona no trobat
exec SEGURETAT.PermisAcces_LlistatZona('Planta baixa', 'Foods1', 'Barcelona Nord', :rc, :status2);
commit;
print status2;
print rc;
-- Test U48_01
-- Procediment: PermisAcces_LlistatPersona
-- Descripci: obt el llistat de permisos d'accs per persona
-- Estat: OK
exec SEGURETAT.PermisAcces_LlistatPersona('47575632V', :rc, :status2);
commit;
print status2;
print rc;
-- Test U48_02
-- Procediment: PermisAcces_LlistatPersona
-- Descripci: obt el llistat de permisos d'accs per persona, perms inexistent per persona
-- Estat: ERROR: permisacces persona no trobat
exec SEGURETAT.PermisAcces_LlistatPersona('48645762A', :rc, :status2);
commit;
print status2;
print rc;
-- Test U49_01
-- Procediment: PermisAcces_LlistatDepartament
-- Descripci: obt el llistat de permisos d'accs per departament
-- Estat: OK
exec SEGURETAT.PermisAcces_LlistatDepartament('Informtica', 'Foods1', 'Barcelona Nord', :rc, :status2);
commit;
print status2;
print rc;
-- Test U49_02
-- Procediment: PermisAcces_LlistatDepartament
-- Descripci: obt el llistat de permisos d'accs per departament, perms inexistent per departament
-- Estat: ERROR: permisacces departament no trobat
exec SEGURETAT.PermisAcces_LlistatDepartament('Gesti', 'Foods1', 'Barcelona Nord', :rc, :status2);
commit;
print status2;
print rc;
-- Test U50_01
-- Procediment: PermisAcces_Esborrar
-- Descripci: elimina permisacces per persona
-- Estat: OK
exec SEGURETAT.PermisAcces_Esborrar('Planta primera', 'Foods1', 'Barcelona Nord', '47575632V', NULL, :status2);
commit;
print status2;
-- Test U50_02
-- Procediment: PermisAcces_Esborrar
-- Descripci: elimina permisacces per departament
-- Estat: OK
exec SEGURETAT.PermisAcces_Esborrar('Planta segona', 'Foods1', 'Barcelona Nord', NULL, 'Informtica', :status2);
commit;
print status2;
-- Test U50_03
-- Procediment: PermisAcces_Esborrar
-- Descripci: elimina permisacces per departament, zona inexistent
-- Estat: ERROR: zona no trobada
exec SEGURETAT.PermisAcces_Esborrar('Planta baixa', 'Foods1', 'Barcelona Nord', NULL, 'Informtica', :status2);
commit;
print status2;
-- Test U50_04
-- Procediment: PermisAcces_Esborrar
-- Descripci: elimina permisacces per persona, persona inexistent
-- Estat: ERROR: persona no trobada
exec SEGURETAT.PermisAcces_Esborrar('Planta primera', 'Foods1', 'Barcelona Nord', '48645762A', NULL, :status2);
commit;
print status2;
-- Test U50_05
-- Procediment: PermisAcces_Esborrar
-- Descripci: elimina perms accs per departament, departament inexistent
-- Estat: ERROR: departament no trobat
exec SEGURETAT.PermisAcces_Esborrar('Planta segona', 'Foods1', 'Barcelona Nord', NULL, 'Gesti', :status2);
commit;
print status2;
-- Test U50_06
-- Procediment: PermisAcces_Esborrar
-- Descripci: elimina perms accs per departament, persona i departaments nulls
-- Estat: ERROR: parmetres incorrectes
exec SEGURETAT.PermisAcces_Esborrar('Planta segona', 'Foods1', 'Barcelona Nord', NULL, NULL, :status2);
commit;
print status2;
-- Test U51_01
-- Procediment: PermisAcces_EsborrarPK
-- Descripci: elimina un perms accs per identificador perms accs
-- Estat: OK
exec SEGURETAT.PermisAcces_EsborrarPK('1', :status2);
commit;
print status2;
-- Test U51_02
-- Procediment: PermisAcces_EsborrarPK
-- Descripci: elimina un perms accs per identificador perms accs, perms accs inexistent
-- Estat: ERROR:permisacces no trobat
exec SEGURETAT.PermisAcces_EsborrarPK('1', :status2);
commit;
print status2;
