set serveroutput on
alter session set nls_date_format = 'DD-MM-YYYY HH24:MI:SS';
VAR status2 VARCHAR2(100);
VAR rc refcursor; 
VAR idRegistre NUMBER;

------------------------------------------------------------------
-- Taula: REGISTRE
-- Test U52_01
-- Procediment: Registre_Inserir
-- Descripci: inserir nou registre
-- Estat: OK
exec USUARI.Registre_Inserir(:idRegistre, 'Foods1', 'Barcelona Nord', 'Planta primera', '45233567L', sysdate-(15/1440), sysdate-(15/1440), :status2);
commit;
print status2;
print idRegistre;
-- Test U52_02
-- Procediment: Registre_Inserir
-- Descripci: inserir nou registre
-- Estat: OK
exec USUARI.Registre_Inserir(:idRegistre, 'Foods1', 'Barcelona Nord', 'Planta primera', '46358419X', sysdate-(15/1440), sysdate-(15/1440), :status2);
commit;
print status2;
print idRegistre;
-- Test U52_03
-- Procediment: Registre_Inserir
-- Descripci: inserir nou registre
-- Estat: OK
exec USUARI.Registre_Inserir(:idRegistre, 'Foods1', 'Barcelona Nord', 'Planta segona', '47575632V', sysdate-(15/1440), sysdate-(15/1440), :status2);
commit;
print status2;
print idRegistre;
-- Test U52_04
-- Procediment: Registre_Inserir
-- Descripci: inserir nou registre, delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec USUARI.Registre_Inserir(:idRegistre, 'Foods1', 'Barcelona Centre', 'Planta Segona', '47575632V', sysdate-(15/1440), sysdate-(15/1440), :status2);
commit;
print status2;
-- Test U52_05
-- Procediment: Registre_Inserir
-- Descripci: inserir nou registre, zona inexistent
-- Estat: ERROR: zona no trobada
exec USUARI.Registre_Inserir(:idRegistre, 'Foods1', 'Barcelona Nord', 'Sala reunions', '47575632V', sysdate-(15/1440), sysdate-(15/1440), :status2);
commit;
print status2;
-- Test U52_06
-- Procediment: Registre_Inserir
-- Descripci: inserir nou registre, persona inexistent
-- Estat: ERROR: persona no trobada
exec USUARI.Registre_Inserir(:idRegistre, 'Foods1', 'Barcelona Nord', 'Planta segona', '44923354F', sysdate-(15/1440), sysdate-(15/1440), :status2);
commit;
print status2;
-- Test U53_01
-- Procediment: Registre_ActSortida
-- Descripci: actualitzar registre hora sortida
-- Estat: OK
exec USUARI.Registre_ActSortida('Foods1', 'Barcelona Nord', 'Planta primera', '45233567L', sysdate, :status2);
commit;
print status2;
-- Test U53_02
-- Procediment: Registre_ActSortida
-- Descripci: actualitzar registre hora sortida
-- Estat: OK
exec USUARI.Registre_ActSortida('Foods1', 'Barcelona Nord', 'Planta primera', '46358419X', sysdate, :status2);
commit;
print status2;
-- Test U53_03
-- Procediment: Registre_ActSortida
-- Descripci: actualitzar registre hora sortida
-- Estat: OK
exec USUARI.Registre_ActSortida('Foods1', 'Barcelona Nord', 'Planta segona', '47575632V', sysdate, :status2);
commit;
print status2;
-- Test U53_04
-- Procediment: Registre_ActSortida
-- Descripci: actualitzar registre hora sortida, delegaci inexistent
-- Estat: ERROR: delegaci no trobada
exec USUARI.Registre_ActSortida('Foods1', 'Barcelona Centre', 'Planta segona', '47575632V', sysdate, :status2);
commit;
print status2;
-- Test U53_05
-- Procediment: Registre_ActSortida
-- Descripci: actualitzar registre hora sortida, zona inexistent
-- Estat: ERROR: zona no trobada
exec USUARI.Registre_ActSortida('Foods1', 'Barcelona Nord', 'Sala reunions', '47575632V', sysdate, :status2);
commit;
print status2;
-- Test U53_06
-- Procediment: Registre_ActSortida
-- Descripci: actualitzar registre hora sortida, persona inexistent
-- Estat: ERROR: persona no trobada
exec USUARI.Registre_ActSortida('Foods1', 'Barcelona Nord', 'Planta segona', '44923354F', sysdate, :status2);
commit;
print status2;
-- Test U53_07
-- Procediment: Registre_ActSortida
-- Descripci: actualitzar registre hora sortida, registre inexistent
-- Estat: ERROR: registre no trobat
exec USUARI.Registre_ActSortida('Foods1', 'Barcelona Nord', 'Planta primera', '47575632V', sysdate, :status2);
commit;
print status2;
-- Test U53_08
-- Procediment: Registre_ActSortida
-- Descripci: actualitzar registre hora sortida, registre ja actualitzat
-- Estat: ERROR: registre ja actualitzat
exec USUARI.Registre_ActSortida('Foods1', 'Barcelona Nord', 'Planta primera', '45233567L', sysdate, :status2);
commit;
print status2;
-- Test U54_01
-- Procediment: Registre_LlistatZona
-- Descripci: obt el llistat de registres per zona entre moment inici i moment fi, registres existents
-- Estat: OK
exec USUARI.Registre_LlistatZona('Planta primera', 'Foods1', 'Barcelona Nord', sysdate-1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U54_02
-- Procediment: Registre_LlistatZona
-- Descripci: obt el llistat de registres per zona entre moment inici i moment fi, zona inexistent a registre
-- Estat: ERROR: zona no registrada
exec USUARI.Registre_LlistatZona('Laboratori', 'Serveis1', 'Barcelona Nord', sysdate-1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U54_03
-- Procediment: Registre_LlistatZona
-- Descripci: obt el llistat de registres per zona entre moment inici i moment fi, registres no trobats
-- Estat: OK
exec USUARI.Registre_LlistatZona('Planta primera', 'Foods1', 'Barcelona Nord', sysdate-2, sysdate-1, :rc, :status2);
commit;
print status2;
print rc;
-- Test U55_01
-- Procediment: Registre_LlistatDelegacio
-- Descripci: obt el llistat de registres per delegaci entre moment inici i moment fi, registres existents
-- Estat: OK
exec USUARI.Registre_LlistatDelegacio('Foods1', 'Barcelona Nord', sysdate-1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U55_02
-- Procediment: Registre_LlistatDelegacio
-- Descripci: obt el llistat de registres per delegaci entre moment inici i moment fi, delegaci inexistent a registre
-- Estat: ERROR: delegaci no registrada
exec USUARI.Registre_LlistatDelegacio('Serveis1', 'Barcelona Nord', sysdate-1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U55_03
-- Procediment: Registre_LlistatDelegacio
-- Descripci: obt el llistat de registres per delegaci entre moment inici i moment fi, registres no trobats
-- Estat: OK
exec USUARI.Registre_LlistatDelegacio('Foods1', 'Barcelona Nord', sysdate-2, sysdate-1, :rc, :status2);
commit;
print status2;
print rc;
-- Test U56_01
-- Procediment: Registre_LlistatPersona
-- Descripci: obt el llistat de registres per persona entre moment inici i moment fi, registres existents
-- Estat: OK
exec USUARI.Registre_LlistatPersona('47575632V', sysdate-1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U56_02
-- Procediment: Registre_LlistatPersona
-- Descripci: obt el llistat de registres per persona entre moment inici i moment fi, persona inexistent a registre
-- Estat: ERROR: persona no registrada
exec USUARI.Registre_LlistatPersona('44923354F', sysdate-1, sysdate, :rc, :status2);
commit;
print status2;
print rc;
-- Test U56_03
-- Procediment: Registre_LlistatPersona
-- Descripci: obt el llistat de registres per persona entre moment inici i moment fi, registres no trobats
-- Estat: OK
exec USUARI.Registre_LlistatPersona('47575632V', sysdate-2, sysdate-1, :rc, :status2);
commit;
print status2;
print rc;
-- Test U57_01
-- Procediment: Registre_Esborrar
-- Descripci: elimina un registre existent segons identificador de registre
-- Estat: OK
exec USUARI.Registre_Esborrar('1', :status2);
commit;
print status2;
-- Test U57_02
-- Procediment: Registre_Esborrar
-- Descripci: elimina un registre inexistent segons identificador de registre
-- Estat: ERROR: registre no trobat
exec USUARI.Registre_Esborrar('1', :status2);
commit;
print status2;
