DECLARE 
  -- declaraci de variables
  p_nomDepartament MDVISITA.nomDepartament%TYPE; 
  p_nomEmpresa     MDVISITA.nomEmpresa%TYPE;
  p_nomDelegacio   MDVISITA.nomDelegacio%TYPE;
  p_numVisites     NUMBER;
  p_sortida        VARCHAR2(150);
  p_CiutatsMesIncidencies ArrayTopCiutatsIncidencies;
  p_MesosMesIncidencies   ArrayIncidMes;
  p_HoresEntradaEdat SYS_REFCURSOR;
  p_HoresEntradaSexe SYS_REFCURSOR;
  p_HoresEntradaMesos SYS_REFCURSOR;
  i                NUMBER;
  vHoraEntrada VARCHAR2(20);
  vSexe        VARCHAR2(20);
  vEdat        NUMBER;
  vMes         NUMBER;
  vNum         NUMBER;
BEGIN
  -- departament amb ms visites
  p_numVisites := 0;
  -- Test U59_01
  -- Procediment: DepartamentMesVisites
  -- Descripci: obt el departament amb ms visites en el mes 5 i any 2015, passats com a parmetres
  -- Estat: OK
  USUARI_BI.DepartamentMesVisites(5, 2015, p_nomDepartament, p_nomEmpresa, p_nomDelegacio, p_numVisites, p_sortida);
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida);
  DBMS_OUTPUT.PUT_LINE('Mes: 5, Any:2015 -> ' || 'Departament:' || p_nomDepartament || ' NomEmpresa:' || p_nomEmpresa || ' NomDelegacio:' || p_nomDelegacio || ' Nmero visites:'|| p_numVisites);  
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U59_02
  -- Procediment: DepartamentMesVisites
  -- Descripci: obt el departament amb ms visites en l'any 2015, passat com a parmetre
  -- Estat: OK
  USUARI_BI.DepartamentMesVisites(0, 2015, p_nomDepartament, p_nomEmpresa, p_nomDelegacio, p_numVisites, p_sortida);
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  DBMS_OUTPUT.PUT_LINE('Any:2015 ---------> ' ||'Departament:' || p_nomDepartament || ' NomEmpresa:' || p_nomEmpresa || ' NomDelegacio:' || p_nomDelegacio || ' Nmero visites:'|| p_numVisites);  
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U59_03
  -- Procediment: DepartamentMesVisites
  -- Descripci: obt el departament amb ms visites del magatzem de dades
  -- Estat: OK
  USUARI_BI.DepartamentMesVisites(0, 0, p_nomDepartament, p_nomEmpresa, p_nomDelegacio, p_numVisites, p_sortida);
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  DBMS_OUTPUT.PUT_LINE('TOTAL ------------> ' ||'Departament:' || p_nomDepartament || ' NomEmpresa:' || p_nomEmpresa || ' NomDelegacio:' || p_nomDelegacio || ' Nmero visites:'|| p_numVisites);  
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U59_04
  -- Procediment: DepartamentMesVisites
  -- Descripci: obt el departament amb ms visites en l'any 2012, passat com a parmetre, cap dada de l'any 2012 al magatzem de dades
  -- Estat: departament no trobat
  USUARI_BI.DepartamentMesVisites(0, 2012, p_nomDepartament, p_nomEmpresa, p_nomDelegacio, p_numVisites, p_sortida);  
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  DBMS_OUTPUT.PUT_LINE('Departament:' || p_nomDepartament || ' NomEmpresa:' || p_nomEmpresa || ' NomDelegacio:' || p_nomDelegacio || ' Nmero visites:'|| p_numVisites);  
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U59_05
  -- Procediment: DepartamentMesVisites
  -- Descripci: obt el departament amb ms visites, parmetres incorrectes (any incorrecte)
  -- Estat: parametres consulta incorrectes
  USUARI_BI.DepartamentMesVisites(5, 0, p_nomDepartament, p_nomEmpresa, p_nomDelegacio, p_numVisites, p_sortida);
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  DBMS_OUTPUT.PUT_LINE('Departament:' || p_nomDepartament || ' NomEmpresa:' || p_nomEmpresa || ' NomDelegacio:' || p_nomDelegacio || ' Nmero visites:'|| p_numVisites);  
  DBMS_OUTPUT.NEW_LINE;  

  -- top 5 ciutats amb ms incidncies (robatoris)
  -- Test U60_01
  -- Procediment: CiutatsMesIncidencies
  -- Descripci: obt les 5 ciutats amb ms incidncies (tipus 'Robatori') en el mes 5 i any 2015, passats com a parmetres
  -- Estat: OK
  p_CiutatsMesIncidencies := ArrayTopCiutatsIncidencies();
  USUARI_BI.CiutatsMesIncidencies(5, 2015, 'Robatori', p_CiutatsMesIncidencies, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> Mes: 5, Any:2015');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  FOR i IN p_CiutatsMesIncidencies.FIRST..p_CiutatsMesIncidencies.LAST 
  LOOP
    DBMS_OUTPUT.PUT_LINE('Ciutat/Pas(' || i || '): '|| p_CiutatsMesIncidencies(i).nomCiutat || '/' || p_CiutatsMesIncidencies(i).nomPais);
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U60_02
  -- Procediment: CiutatsMesIncidencies
  -- Descripci: obt les 5 ciutats amb ms incidncies (tipus 'Robatori') en l'any 2015, passat com a parmetre
  -- Estat: OK
  p_CiutatsMesIncidencies := ArrayTopCiutatsIncidencies();
  USUARI_BI.CiutatsMesIncidencies(0, 2015, 'Robatori', p_CiutatsMesIncidencies, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> Any:2015');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  FOR i IN p_CiutatsMesIncidencies.FIRST..p_CiutatsMesIncidencies.LAST 
  LOOP
    DBMS_OUTPUT.PUT_LINE('Ciutat/Pas(' || i || '): '|| p_CiutatsMesIncidencies(i).nomCiutat || '/' || p_CiutatsMesIncidencies(i).nomPais);
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U60_03
  -- Procediment: CiutatsMesIncidencies
  -- Descripci: obt les 5 ciutats amb ms incidncies (tipus 'Robatori') del magatzem de dades
  -- Estat: OK
  p_CiutatsMesIncidencies := ArrayTopCiutatsIncidencies();
  USUARI_BI.CiutatsMesIncidencies(0, 0, 'Robatori', p_CiutatsMesIncidencies, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> TOTAL');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  FOR i IN p_CiutatsMesIncidencies.FIRST..p_CiutatsMesIncidencies.LAST 
  LOOP
    DBMS_OUTPUT.PUT_LINE('Ciutat/Pas(' || i || '): '|| p_CiutatsMesIncidencies(i).nomCiutat || '/' || p_CiutatsMesIncidencies(i).nomPais);
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U60_04
  -- Procediment: CiutatsMesIncidencies
  -- Descripci: obt les 5 ciutats amb ms incidncies (tipus 'Robatori'), parmetres incorrectes (any incorrecte)
  -- Estat: parametres consulta incorrectes
  p_CiutatsMesIncidencies := ArrayTopCiutatsIncidencies();
  USUARI_BI.CiutatsMesIncidencies(12, 0, 'Robatori', p_CiutatsMesIncidencies, p_sortida);
  DBMS_OUTPUT.PUT_LINE('Parmetres consulta incorrectes');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  DBMS_OUTPUT.NEW_LINE;  

  -- mesos amb ms incidncies
  -- Test U61_01
  -- Procediment: MesosMesIncidencies
  -- Descripci: obt els mesos amb ms incidncies (tipus 'Robatori') de l'any 2015, passat com a parmetre
  -- Estat: OK
  p_MesosMesIncidencies := ArrayIncidMes();
  USUARI_BI.MesosMesIncidencies(2015, 'Robatori', p_MesosMesIncidencies, p_sortida);
  DBMS_OUTPUT.PUT_LINE('Parmetres consulta -> Any:2015');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida);   
  FOR i IN p_MesosMesIncidencies.FIRST..p_MesosMesIncidencies.LAST 
  LOOP
    DBMS_OUTPUT.PUT_LINE('Mes/Nm.incidncies(' || i || '): '|| p_MesosMesIncidencies(i).mMes || '/' || p_MesosMesIncidencies(i).numeroIncid);
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  

  -- hores entrada per edat
  -- Test U62_01
  -- Procediment: HoresEntradaPerEdat
  -- Descripci: obt les hores d'entrada (redondejades al quart d'hora superior ms proper) per edat del mes 5 i any 2015, passats com a parmetres
  -- Estat: OK
  USUARI_BI.HoresEntradaPerEdat(5, 2015, p_HoresEntradaEdat, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> Mes: 5, Any:2015');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  
  LOOP
    FETCH p_HoresEntradaEdat INTO vHoraEntrada,vEdat, vNum;
    EXIT WHEN p_HoresEntradaEdat%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE('Hora entrada (interval 15 min): ' || vHoraEntrada ||' Edat: ' || vEdat || ' Nmero: ' || vNum);
    --|| ' Edat: ' || vEdat ||| ' nmero: ' || vNum); 
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U62_02
  -- Procediment: HoresEntradaPerEdat
  -- Descripci: obt les hores d'entrada (redondejades al quart d'hora superior ms proper) per edat de l'any 2015, passat com a parmetre
  -- Estat: OK
  USUARI_BI.HoresEntradaPerEdat(0, 2015, p_HoresEntradaEdat, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> Any:2015');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  LOOP
    FETCH p_HoresEntradaEdat INTO vHoraEntrada,vEdat, vNum;
    EXIT WHEN p_HoresEntradaEdat%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE('Hora entrada (interval 15 min): ' || vHoraEntrada ||' Edat: ' || vEdat || ' Nmero: ' || vNum);
    --|| ' Edat: ' || vEdat ||| ' nmero: ' || vNum); 
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U62_03
  -- Procediment: HoresEntradaPerEdat
  -- Descripci: obt les hores d'entrada (redondejades al quart d'hora superior ms proper) del magatzem de dades
  -- Estat: OK
  USUARI_BI.HoresEntradaPerEdat(0, 0, p_HoresEntradaEdat, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> TOTAL');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  LOOP
    FETCH p_HoresEntradaEdat INTO vHoraEntrada,vEdat, vNum;
    EXIT WHEN p_HoresEntradaEdat%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE('Hora entrada (interval 15 min): ' || vHoraEntrada ||' Edat: ' || vEdat || ' Nmero: ' || vNum);
    --|| ' Edat: ' || vEdat ||| ' nmero: ' || vNum); 
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U62_04
  -- Procediment: HoresEntradaPerEdat
  -- Descripci: obt les hores d'entrada (redondejades al quart d'hora superior ms proper), parmetres incorrectes (any incorrecte)
  -- Estat: parametres consulta incorrectes
  USUARI_BI.HoresEntradaPerEdat(5, 0, p_HoresEntradaEdat, p_sortida);
  DBMS_OUTPUT.PUT_LINE('Parmetres consulta incorrectes');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida);
  DBMS_OUTPUT.NEW_LINE;  
  
  -- hores entrada per sexe
  -- Test U63_01
  -- Procediment: HoresEntradaPerSexe
  -- Descripci: obt les hores d'entrada per sexe del mes 5 i any 2015, passats com a parmetres
  -- Estat: OK
  USUARI_BI.HoresEntradaPerSexe(5, 2015, p_HoresEntradaSexe, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> Mes: 5, Any:2015');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  LOOP
    FETCH p_HoresEntradaSexe INTO vHoraEntrada,vSexe, vNum;
    EXIT WHEN p_HoresEntradaSexe%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE('Hora entrada (interval 15 min): ' || vHoraEntrada ||' Sexe: ' || vSexe || ' Nmero: ' || vNum); 
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U63_02
  -- Procediment: HoresEntradaPerSexe
  -- Descripci: obt les hores d'entrada per sexe de l'any 2015, passat com a parmetre
  -- Estat: OK
  USUARI_BI.HoresEntradaPerSexe(0, 2015, p_HoresEntradaSexe, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> Any:2015');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  LOOP
    FETCH p_HoresEntradaSexe INTO vHoraEntrada,vSexe, vNum;
    EXIT WHEN p_HoresEntradaSexe%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE('Hora entrada (interval 15 min): ' || vHoraEntrada ||' Sexe: ' || vSexe || ' Nmero: ' || vNum);
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U63_03
  -- Procediment: HoresEntradaPerSexe
  -- Descripci: obt les hores d'entrada per sexe del magatzem de dades
  -- Estat: OK
  USUARI_BI.HoresEntradaPerSexe(0, 0, p_HoresEntradaSexe, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> TOTAL');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  LOOP
    FETCH p_HoresEntradaSexe INTO vHoraEntrada,vSexe, vNum;
    EXIT WHEN p_HoresEntradaSexe%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE('Hora entrada (interval 15 min): ' || vHoraEntrada ||' Sexe: ' || vSexe || ' Nmero: ' || vNum);
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U63_04
  -- Procediment: HoresEntradaPerSexe
  -- Descripci: obt les hores d'entrada per sexe, parmetres incorrectes (any incorrecte)
  -- Estat: parametres consulta incorrectes
  USUARI_BI.HoresEntradaPerSexe(5, 0, p_HoresEntradaSexe, p_sortida);
  DBMS_OUTPUT.PUT_LINE('Parmetres consulta incorrectes');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida);
  DBMS_OUTPUT.NEW_LINE;  

  -- hores d'entrada per mesos
  -- Test U64_01
  -- Procediment: HoresEntradaPerMesos
  -- Descripci: obt les hores d'entrada per mesos de l'any 2015, passat com a parmetre
  -- Estat: OK
  USUARI_BI.HoresEntradaPerMesos(2015, p_HoresEntradaMesos, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> Any:2015');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  LOOP
    FETCH p_HoresEntradaMesos INTO vHoraEntrada,vMes,vNum;
    EXIT WHEN p_HoresEntradaMesos%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE('Hora entrada (interval 15 min): ' || vHoraEntrada ||' Mes: ' || vMes || ' Nmero: ' || vNum);
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  -- Test U64_02
  -- Procediment: HoresEntradaPerMesos
  -- Descripci: obt les hores d'entrada per mesos del magatzem de dades
  -- Estat: OK
  USUARI_BI.HoresEntradaPerMesos(0, p_HoresEntradaMesos, p_sortida);
  DBMS_OUTPUT.PUT_LINE(' Parmetres consulta -> TOTAL');
  DBMS_OUTPUT.PUT_LINE('Estat: ' || p_sortida); 
  LOOP
    FETCH p_HoresEntradaMesos INTO vHoraEntrada,vMes,vNum;
    EXIT WHEN p_HoresEntradaMesos%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE('Hora entrada (interval 15 min): ' || vHoraEntrada ||' Mes: ' || vMes || ' Nmero: ' || vNum);
  END LOOP;
  DBMS_OUTPUT.NEW_LINE;  
  
END; 
/